'<ADbasic Header, Headerversion 001.001>
' Foldings                       = 81,205,419
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--Inc--PRO
'<SMARTFORMAT OFF> do not remove !!!
'
'#################################################################
'#                        ADwin-X.inc                            #
'#              INCLUDE-file for ADwin-X-system                  #
'#################################################################
'#                                                               #
'# Contents: Definition of functions and procedures              #
'#           to access ADwin PRO SYSTEM                          #
'#                                                               #
'#  17.11.2016  mf   creation                                    #
'#  22.02.2017  mf   can                                         #
'#  16.03.2017  mf   rs232                                       #
'#                                                               #
'# Attention:                                                    #
'#   - Do not copy the first source line (containing             #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !                #
'#     Otherwise the Syntax color may be not correct.            #
'#   - This includefile requires ADbasic 5 or higher!            #
'#                                                               #
'#################################################################
import adwin-x-lib.1.lic
import Emmc.1.lic

#if adwin_system = ADwin_X
#else
#error("This include file can only be used with the ADwin-X")
#endif

'#define SYST_CPU 50000000H
'#define WATCHDOG   50004000h        ''<HIDE> 
'#define WD_TIMER   50004000h        ''<HIDE>  

#define CPU_DIG_ADR 50002100H       
#define CPU_DIG_ADR1 50002200H     
#define CPU_DIG_CONFIG 50002000H


#define CAN_SRR 0  ''<HIDE> 
#define CAN_MSR 4  ''<HIDE> 
#define CAN_BRPR 8  ''<HIDE> 
#define CAN_BTR 12  ''<HIDE> 
#define CAN_ECR 10H  ''<HIDE> 
#define CAN_ESR 14H  ''<HIDE> 
#define CAN_SR 18H  ''<HIDE> 
#define CAN_ISR 1CH  ''<HIDE> 
#define CAN_IER 20H  ''<HIDE> 
#define CAN_ICR 24H  ''<HIDE> 
#define CAN_TCR 28H  ''<HIDE> 
#define CAN_WIR 2CH  ''<HIDE> 
#define CAN_TXFIFO_ID 30H   ''<HIDE> 
#define CAN_TXFIFO_DLC 34H  ''<HIDE> 
#define CAN_TXFIFO_Data1 38H  ''<HIDE> 
#define CAN_TXFIFO_Data2 3CH  ''<HIDE> 
#define CAN_TXHPB_ID 40H   ''<HIDE> 
#define CAN_TXHPB_DLC 44H   ''<HIDE> 
#define CAN_TXHPB_DATA1 48H  ''<HIDE> 
#define CAN_TXHPB_DATA2 4CH   ''<HIDE> 
#define CAN_RXFIFO_ID 50H  ''<HIDE> 
#define CAN_RXFIFO_DLC 54H   ''<HIDE> 
#define CAN_RXFIFO_DATA_1 58H  ''<HIDE> 
#define CAN_RXFIFO_DATA_2 5CH   ''<HIDE> 
#define CAN_AFR 60H   ''<HIDE> 
#define CAN_AFMR1 64H   ''<HIDE> 
#define CAN_AFIR1 68H  ''<HIDE> 
#define CAN_AFMR2 6CH  ''<HIDE> 
#define CAN_AFIR2 70H  ''<HIDE> 
#define CAN_AFMR3 74H  ''<HIDE> 
#define CAN_AFIR3 78H  ''<HIDE> 
#define CAN_AFMR4 7CH  ''<HIDE> 
#define CAN_AFIR4 80H  ''<HIDE> 

' 1...8 data bytes 
' 9 lenght
' 10 ID
' 11 Timestamp
dim CAN_Msg[11] as long


'<REGION> System




'******************************************************************************
' If a low-priority process accesses a Pro-module it must not be
' interrupted by any other process !!!
'******************************************************************************
SUB SUB_BEGIN_CRITICAL_SECTION() ''<HIDE>
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
ENDSUB

SUB SUB_END_CRITICAL_SECTION() ''<HIDE>
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
ENDSUB


SUB SUB_BEGIN_CRITICAL_SECTION_LOW() ''<HIDE>
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION_LOW  
#ENDIF
ENDSUB
  
SUB SUB_END_CRITICAL_SECTION_LOW() ''<HIDE>
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION_LOW
#ENDIF
ENDSUB


Sub System_Array_Debug_Check(array[], startindex, length)  '<HIDE>
#IF DEBUG_MODE = ON THEN
  if ((startindex) + (length) - 1 > Get_Array_Length(array)) then
    PROZESS_FEHLER = 0C1000000H or Get_Array_No(array)
    end_exit
  endif
  ''  
  if ((startindex) < 1) then 
    PROZESS_FEHLER = 0C2000000H or Get_Array_No(array)
    end_exit
  endif
#endif
ENDSUB



Function SizeOfArrayElement(array[]) As Long '<HIDE>
  SizeOfArrayElement = 1
  If (if_type_byte(array) = 1) then SizeOfArrayElement = 1
  If (if_type_short(array) = 1) then SizeOfArrayElement = 2
  If (if_type_long(array) = 1) then SizeOfArrayElement = 4
  If (if_type_float(array) = 1) then SizeOfArrayElement = 8 ' double!
  If (if_type_float32(array) = 1) then SizeOfArrayElement = 4
EndFunction



**************************************************************
''' Converts a process frequency [Hz] into processor ticks (processdelay or cycle time).
''' frequency:  frequency[Hz]
'''*************************************************************
Function Calc_Processdelay(frequency) as long
  calc_processdelay=666666666.6666666666/(frequency)
endfunction

 
  
'******************************************************************************
'''Switches a LED on or off.
'''value: 
'''+ 0->off
'''+ 1->on
'''******************************************************************************
SUB Set_CPU_LED(value)
  POKE(50001100h, value)
ENDSUB

******************************************************************************
'''Checks the LED on a module or cpu.
'''****************************************************************************
FUNCTION Check_CPU_LED(module) AS Long
  CHECK_CPU_LED = (PEEK(50001100h) and 1)
ENDFUNCTION


'******************************************************************************
'''Checks whether the DIG_IN (channel) is activated.
'''+  activated = the selected edge (CPU_Dig_IO_Config) has been received
'''+  result: 
'''+           0->no edge detected
'''+           1->selected edge has been detected at least once
'''channel: 0/1
'''****************************************************************************
FUNCTION CPU_Digin(channel) AS Long 
  CPU_DIGIN = shift_right(peek(cpu_DIG_ADR + (256 * channel)), 1) AND 1
ENDFUNCTION

'******************************************************************************
'''Configures cpu_dig_io.
'''pattern:
'''+  BIT 0 DIG IO 0   (DIG I/O 0  0= INPUT, 1= OUTPUT)
'''+  BIT 1 DIG IO 0   (0= falling edge, 1= rising edge if DIG IO 0 is input)
'''+  BIT 4 DIG IO 1   (DIG I/0 1  0= INPUT, 1= OUTPUT)
'''+  BIT 5 DIG IO 1   (0= falling edge, 1= rising edge if DIG IO 1 is input)
'''****************************************************************************
SUB CPU_Dig_IO_Config(pattern)
  poke(cpu_DIG_CONFIG, pattern)  
ENDSUB

'******************************************************************************
'''Sets the digital output DIG IO 0/1 on the cpu.
'''channel: 0/1
'''value: output 0 or 1
'''****************************************************************************
SUB CPU_Digout(channel, value) 
  poke(CPU_DIG_ADR + channel * 256, value AND 1)
ENDSUB
'<ENDREGION>

'<REGION> CAN
*************************************************************************
''' Sets a register of the CAN-controller.
''' channel : number of the CAN interface on the CAN module
''' regno: register which should be set (relative address)
''' value: value which should be written to the register.
'''****************************************************************************
Sub CAN_Set_Reg(channel, regno, value)
  poke(0E0007000H + (regno)+((channel)*1000H),value)
EndSub


'******************************************************************************
''' Reads a register of the CAN-controller.
'''+ return value : value of the register
''' channel: number of the CAN interface on the CAN module
''' regno: register to read (relative address)
'''****************************************************************************
Function CAN_Get_Reg(channel, regno) As Long
  CAN_Get_Reg=peek(0E0007000H + (regno)+((channel)*1000H))
EndFunction  




''' Initialises the CAN-controller.
'''+Sets the baudrate of the CAN-Bus.
'''+return value 
'''+             0 = baudrate is set
'''+             1 = the selected baudrate is not set
'''channel: number of the CAN interface on the CAN module
'''+(also necessary If the module provides only one channel)
'''baudrate: CAN-Bus baudrate
'''*****************************************************************************
Function CAN_Init(channel, baudrate) as long
  Dim fbuffer As long
  Dim scale As Long
  Dim hbaud as long
  Dim hscale as long
  Dim brp As Long
  Dim back As Long
  Dim btr0 As Long
  Dim btr1 As Long
  Dim tseg1 As Long
  Dim tseg2 As Long
  'mio 0  
  poke(0E000A204H, 1)                                       'richtung
  poke(0E000A000H, 0)
  poke(0E000A208H, 1)                                       'enable
  poke(0E000A040H, 1)                                       'wert
  'mio block entfllt spter oder wird anderst end 
  
  fbuffer = 20000000 / baudrate                             ' 20Mhz Clock

  scale = fbuffer                                           'total scale to achive the baudrate
  hbaud = (fbuffer) * baudrate

  If (absi(hbaud - 20000000) < 1100) then
    CAN_INIT = 0                                            
  Else
    CAN_INIT = 1                                            ' 1 If baudrate not possible
  EndIf
  
  If (CAN_INIT = 0) Then                                    'If baudrate possible then find settings
    brp = (scale - 1) / 25                                  'Prescaler
    Do                                                      'find the right brp
      fbuffer = scale / (brp + 1) - 3
      hscale = (fbuffer + 3) * (brp + 1)                    'Inc prescaler until tseg1 + tseg 2 is a Long
      back = scale - hscale
      Inc(brp)
    Until ((back = 0) Or (fbuffer < 5))
    Dec(brp)
    If (back <> 0) Then CAN_INIT = 1                        ' 1 If baudrate not possible
  EndIf
  
  If (CAN_INIT = 0) Then                                    'If there is a correct prescaler
    tseg2 = fbuffer * 4 / 10
    tseg1 = fbuffer - tseg2
    If (tseg2 > 7) Then
      Do
        Dec(tseg2)
        Inc(tseg1)
      Until (tseg2 = 7)
    EndIf
    btr0 = brp                                              'Synchronization jump width = 1 (bits = 0)
    btr1 = tseg1 + Shift_Left(tseg2, 4)                     'one sampling each Bit
  endif
  
  can_OM_CONFIG_set(channel)
  
  
  CAN_set_reg(channel, CAN_BRPR, btr0)
  can_BTR_set(channel, 0, tseg2, tseg1)                    
  can_OM_NORMAL_set(channel)
  CAN_Set_reg(channel, CAN_AFR, 0)                          'all Rx-Filter off
  
ENDFUNCTION

' Bit timing register
' sjw: 0..1
' ts2: 0..2
' ts1: 0..3
sub CAN_BTR_set(channel, sjw, ts2, ts1)  ''<HIDE> 
  dim _t as long
  
  _t = ts1 and 0Fh
  _t = _t or (shift_left((ts2 and 07h), 4))
  _t = _t or (shift_left((sjw and 03h), 7))
  CAN_set_reg(channel, CAN_BTR, _t)
endsub

' enter Normal mode
sub can_OM_NORMAL_set(channel)  ''<HIDE> 
  CAN_set_reg(channel, CAN_MSR, 000b)                            ' SNOOP: 0, LBACK: 0, SLEEP: 0
  CAN_set_reg(channel, CAN_SRR, 10b)                             ' CEN: 1, SRST: 0
endsub

   
' enter configuration mode
sub can_OM_CONFIG_set(channel)   ''<HIDE> 
  ' sw reset
  ' self clearing ?
  CAN_set_reg(channel, CAN_SRR, 1)                               ' CEN: 0, SRST: 
  'CAN_set_reg(ch, CAN_SRR, 0)                               ' CEN: 0, SRST: 0
endsub



''' Function Set RX Filter 
''' ret_val:  0: no err 
'''+         <>0: err (no filter is set)
''' channel: 1..2
''' FilterNo: 1..4
''' Filter_Enable: =0: disable
'''               <>0: enable
''' CAN_ID: 11 / 29 bit ID
''' extended_id 0: 11, 1: 29
function CAN_RX_Set_Filter(channel, FilterNo, Filter_Enable, CAN_ID, extended_id) as long
  dim _AFRo as long
  dim fb as long
  dim ret as long
  dim _to as long
  dim _t as long

  _AFRo = CAN_Get_reg(channel, CAN_AFR)
  CAN_Set_reg(channel, CAN_AFR, 0)                          ' all Filter disable
  _to = 0
  do
    inc _to
    ret = shift_right(CAN_Get_reg(channel, CAN_SR), 11) and 1  ' check disable ca 120nsec
  until ((ret = 0) or (_to = 100))                          ' ca. 0.012ms TO

  if (ret = 0) then                                         'OK
    if (extended_id = 1) then                               ' 29bit
      CAN_Set_reg(channel, 5CH + ((FilterNo) * 8), 0FFFFFFFFh)  'set AFMRx 1..4
      _t = shift_left(CAN_ID, 21)
      _t = _t or shift_left(1, 20)                          ' SRR
      _t = _t or shift_left(1, 19)                          ' IDE
      _t = _t or (shift_left(shift_right((CAN_ID and 1FFFF800h), 11), 1))  'ext,18)

      CAN_SET_reg(channel, 60H + ((FilterNo) * 8), _t)        'set AFIRx 1..4             
      
    else
      CAN_Set_reg(channel, 5CH + ((FilterNo) * 8), 0FFF80000h)  'set AFMRx 1..4
      _t = shift_left(CAN_ID, 21)
      CAN_SET_reg(channel, 60H + ((FilterNo) * 8), _t)        'set AFIRx 1..4             
    endif
    fb = shift_left(1, (FilterNo) - 1)
    if (Filter_Enable = 0) then 
      _AFRo = _AFRo AND Not(fb)                             ' disable
    else 
      _AFRo = _AFRo or fb                                   ' enable
    endif
    CAN_Set_reg(channel, CAN_AFR, _AFRo)
    CAN_RX_Set_Filter = 0
  else 
    CAN_Set_reg(channel, CAN_AFR, _AFRo)
    CAN_RX_Set_Filter = -1                                  ' disable not possible
  endif
endfunction



''' Reads can_message from the receive FIFO.
'''+ CAN_MSG
'''+ 1...8 data
'''+ 9 length
'''+ 10 ID
'''+ 11 Timestamp
'''+return value: 
'''+ ret: -1 no bytes in the receive FIFO
'''+    <>-1 ID from message
''' channel: number of the CAN interface (1..2)
Function CAN_Receive(channel) as long
  CAN_Receive=CAN_Receive_lib(channel,can_msg)
ENDFUNCTION


''' Transmits a frame.
'''+return value: 
'''+ -1 = buffer full
'''+  0 = ok 
''' channel: number of the CAN interface (1..2)
''' prio: 
'''+ =0 fifo mode (writes message to out fifo)
'''+ =1 hpb Mode  
''' extended_id 0: 11, 1: 29
'''****************************************************************************
Function CAN_Transmit(channel, prio, extended_id) as long
  CAN_Transmit=CAN_Transmit_lib(channel,prio,extended_id,can_msg)
endfunction

'<ENDREGION>

'<REGION> RS232
*************************************************************************
''' Sets a register of the RS-controller.
''' channel: (1) number of the RS interface
''' regno: register which should be set (relative address)
''' value: value which should be written to the register.
'''****************************************************************************
Sub RS_Set_Reg(channel, regno, value)
  poke(0DFFFF000H + (regno)+((channel)*1000H),value)
EndSub


'******************************************************************************
''' Reads a register of the RS-controller.
'''+ return value : value of the register
''' channel: 1 number of the RS interface 
''' regno: register to read (relative address)
'''****************************************************************************
Function RS_Get_Reg(channel, regno) As Long
  RS_Get_Reg=peek(0DFFFF000H + (regno)+((channel)*1000H))
EndFunction  


'******************************************************************************
'''Initialises a serial interface.
'''channel: (1) number of the serial interface
'''baud_rate: Baudrate for the serial comunication
'''+  115200
'''+   57600
'''+   38400
'''+   19200
'''+    9600
'''+    4800
'''+    2400
'''+    1200
'''+     600
'''+     300
'''+  other baudrates possible
'''parity:     
'''+             0 = no parity
'''+             1 = even
'''+             2 = odd
'''word_length: Number of databits for the serial comunication (6..8)
'''stop_bits:   
'''+             0 = 1 Stopbit
'''+             1 = 1, 5 Stopbits 
'''+             2 = 2 Stopbits 
'''handshake:   
'''+             0 = RS-232 no handshake
'''****************************************************************************
sub RS_Init(channel, baud_rate, parity, word_length, stop_bits, handshake)
  
  
  dim mode as long
  dim S1,p1,w1 as long
  
  dim BDIV,CD,DIV8 as long
  
  RS_Set_Reg(channel, 0,101000B) 'CONTROL REG0 RX and TX disable 
  
  
  s1=stop_bits AND 11B
  mode=shift_left(s1,6)
  
  
  p1=0
  if (parity=0) then p1=111B 'no parity
  if (parity=1) then p1=0 'even
  if (parity=2) then p1=001B 'odd
  
  mode=mode or shift_left(p1,3)
  
  w1=0
  if (word_length=6) then w1=11B
  if (word_length=7) then w1=10B
  if (word_length=8) then w1=00B
  
  mode=mode or shift_left(w1,1)
  
  'mode=mode or shift_left(10B,8) 'loopback only debug
   
  rs_clock_calc(baud_rate,BDIV,CD,DIV8)
  
  mode=mode or div8
  
  RS_Set_Reg(channel, 4H, mode) 'MODE REG0 control reg. 
  
  RS_Set_Reg(channel, 18H,CD) 'BAUD_RATE_GEN_REG
  RS_Set_Reg(channel, 34H,BDIV) 'BAUD_RATE_DIVIDER_REG
  
  RS_Set_Reg(channel, 1CH,0) 'RCVR_TIMEOUT_REG
  RS_Set_Reg(channel, 20H,32) 'RCVR_FIFO_TRIGGER_LEV
  
  if (handshake=0) then 
    RS_Set_Reg(channel, 24H,0) 'MODEM CONTROL REGISTER
    RS_Set_Reg(channel, 38H,0) 'FLOW CONTROL DELAY REGISTER
  else
    RS_Set_Reg(channel, 24H,shift_left(1,5)) ' 'MODEM CONTROL REGISTER ungetestet 
    RS_Set_Reg(channel, 38H,32) ' 'FLOW CONTROL DELAY REGISTER ????
  endif   
 
  RS_Set_Reg(channel, 44H,32) 'TX_FIFO_TRIGGER_LEV
  
  RS_Set_Reg(channel, 0, 11B) 'CONTROL REG0 reset rx tx 
  RS_Set_Reg(channel, 0, 00010100B) 'CONTROL REG0 enable rx tx 

endsub




SUB RS_CLOCK_CALC(Baud,BDIV,CD,d8)'<HIDE>
  
  dim i as long
  dim sCD as float
  dim sCD2 as long
  DIM BaudI as float
  Dim CErr as float
  dim CErr2 as float
  
  dim help1 as float
  dim help2 as float
  

  cerr2=1000000

  if (baud<300) then   
    help1=(12500000/Baud)
    help2=12500000
    d8=1  'ref takt = ref takt /8 
  else
    help1=(100000000/Baud)
    help2=100000000
    d8=0
  endif
 
  for i=5 to 20
 
    SCD=(help1/i)+0.5 
    SCD2=SCD

    BaudI=help2/(SCD2*i)
    Cerr=absf(baud-baudi)
      
    if ((cerr<cerr2) AND (scd2<65536)) then 
      bdiv=i-1
      cd=sCD2
      cerr2=cerr
    endif  
  next
  
endsub
  










'
'
'
'SUB RS_CLOCK_CALC(Baud,BDIV,CD)'<HIDE>
'  
'  dim i as long
'  dim sCD as float
'  dim sCD2 as long
'  DIM sCDI as float
'  Dim CErr as float
'  dim CErr2 as float
'  
'  cerr2=1000000
'  
'  for i=5 to 32
' 
'    SCD=((100000000/Baud)/i)+0.5 
'    SCD2=SCD
'
'    sCDI=100000000/(SCD2*i)
'  
'    CErr= absf((1-(baud/sCDI))*100)
'    
'    if (cerr<cerr2) then 
'      bdiv=i-1
'      cd=sCD2
'      cerr2=cerr
'    endif
'  
'  next
'  
'  
'  
'endsub
'  




'******************************************************************************
'''Writes a byte to the transmit FIFO, if the FIFO is not full.
'''+return value:
'''+write_fifo: 
'''+            0 = byte is written
'''+            1 = FIFO full
'''channel: (1) number of the serial interface 
'''value: value which should be written to the FIFO
'''****************************************************************************
function RS_Write_FIFO(channel, value) as Long
  '
  dim status as long
  
  status=RS_Get_Reg(channel, 2CH) AND 10000B 'status
  if (status>0) then 
    RS_Write_FIFO=1
  else
    RS_Set_Reg(channel, 30H, value) 'write fifo          
    RS_Write_FIFO=0
  endif
    
endfunction


'******************************************************************************
'''Checks if write fifo is full.
'''+ return value:
'''+             0->one or more byte in write fifo is free
'''+             1->FIFO full
'''channel:(1) number of the serial interface
'''***************************************************************
function RS_Write_FIFO_Full(channel) as Long
  dim status as long
  status=RS_Get_Reg(channel, 2CH) AND 10000B 'status
  
  if (status>0) then 
    RS_Write_FIFO_Full=1
  else 
    RS_Write_FIFO_Full=0
  endif
endfunction


'******************************************************************************
'''Checks if write fifo is empty
'''+ return value:
'''+             0->one or more byte in write fifo or shift_register
'''+             1->FIFO and output shift_register empty
'''channel: (1) number of the serial interface
'''***************************************************************
function RS_Write_FIFO_Empty(channel) as Long
  dim status as long
  dim empty as long
  dim shift_register as long
  status=RS_Get_Reg(channel, 2CH) 'status
  empty=status AND 1000B '0 = not empty
  shift_register=shift_right(status,11) AND 1  
  
  if ((empty>0) AND (shift_register=0)) then 
    RS_Write_FIFO_Empty=1
  else 
    RS_Write_FIFO_Empty=0
  endif
endfunction

'******************************************************************************
'''Reads byte from the receive FIFO return value:
'''+read_fifo: 
'''+        0 - 255 = value of the received byte
'''+       -1 = no bytes in the receive FIFO
'''channel: (1) number of the serial interface 
'''****************************************************************************
function RS_Read_FIFO(channel) as Long
 
  dim status as long
  
  status=RS_Get_Reg(channel, 2CH) AND 10B 'status
  
  
  if (status>0) then 
    RS_Read_FIFO=-1
  else
    RS_Read_FIFO=RS_Get_Reg(channel, 30H) 'read fifo
  endif
endfunction



'<ENDREGION>


'<REGION> ADC
'******************************************************************************
''' Samples, converts and reads out the digital 16 bit ADC-value.
'''+ Attention:                                                 
'''+ This instruction is not prepared to handle an access from  
'''+ a low AND high priority process to the same module.     
'''+ result: 16 bit Long
''' channel: channel number of analog input
'''****************************************************************************
FUNCTION ADC(channel) as Long
  ADC=1

ENDFUNCTION





'******************************************************************************
''' Samples, converts and reads out the digital 18 bit ADC-value.
'''+  Attention:                                                 
'''+  This instruction is not prepared to handle an access from  
'''+  a low AND high priority process to the same module.        
'''+ result: 24 bit Long
''' channel: channel number of analog input
'''****************************************************************************
FUNCTION ADC24(channel) as Long
  ADC24=2
ENDFUNCTION



'*****************************************************************************
'''Transfers the input data from channel 1..8 to an array.
'''array[]: destination array
'''index: start index at the destination array
'''*****************************************************************************
SUB P2_Read_ADC8(array[], index)
  
  dim zufall as long
  
  inc zufall   
  array[1]=(zufall +10 ) AND 0FFFFH
  array[2]=(zufall +20 ) AND 0FFFFH
  array[3]=(zufall +30 ) AND 0FFFFH
  array[4]=(zufall +40 ) AND 0FFFFH
  array[5]=(zufall +50 ) AND 0FFFFH
  array[6]=(zufall +60 ) AND 0FFFFH
  array[7]=(zufall +70 ) AND 0FFFFH
  array[8]=(zufall +80 ) AND 0FFFFH
  
  System_Array_Debug_Check(array, index, 8)
  SUB_BEGIN_CRITICAL_SECTION
  SUB_END_CRITICAL_SECTION
ENDSUB


'*****************************************************************************
'''Transfers the input data from channel 1..8 to an array.
'''array[]: destination array
'''index: start index at the destination array
'''*****************************************************************************
SUB P2_Read_ADC8_24B(array[], index)
  System_Array_Debug_Check(array, index, 8)
  SUB_BEGIN_CRITICAL_SECTION
  SUB_END_CRITICAL_SECTION
ENDSUB

  
  
'<ENDREGION>




'<REGION> DAC

'******************************************************************************
''' Converts the digitial value to an analog output.
''' dac_no: channel number of analog output
''' value:  output value (0..65535)
'''****************************************************************************
SUB DAC(dac_no, value)
  'poke(0c00002Eh + (DAC_No) * 2, value)
ENDSUB

'******************************************************************************
''' Sets DAC-register to desired value.
''' nr: channel number of analog output
''' value:  output value (0..65535)
'''****************************************************************************
SUB Write_DAC(dac_no, value)
  'poke(0c00001Eh + (dac_no) * 2, value)
ENDSUB


'******************************************************************************
''' Simultaneously starts conversion of all DACs.
'''****************************************************************************
SUB Start_DAC()
  'poke(0c000004h, 0fbh)
ENDSUB


'<ENDREGION>

'<REGION> LS-BUS Adresen stimmen alle noch nicht !

'---------------------------------------------------------------
' Function only For internal use!
' receive LS-Bus
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
' return  : error code (0->ok)
'---------------------------------------------------------------
Function I_Receive(dev_adr, reg_adr, cnt_dat, buf[]) As Long ''<HIDE>
  Dim cnt_i, frc, ftc, tmout, tmstart, th As Long
  Dim ret As Long

  do
    ftc = Peek(00001015h)              ' tx FIFO count
  until (ftc < 28)                                          ' platz zum senden
  Sub_begin_critical_section
  poke(00001010h, (Shift_Left(cnt_dat - 1, 4) Or dev_adr))  ' Header 1
  nop
  poke(00001010h, reg_adr)              ' Header 2
  Sub_End_critical_section
  io_sleep(20)
  Do
    ftc = Peek(00001015h)                ' tx FIFO count
  Until (ftc = 0)
  th = 7280                                                 ' first 6.75 mikrosec
  For cnt_i = 1 To cnt_dat                                  ' data count
    tmstart = Read_Timer_sync()
    Do                                                      ' rx wait
      tmout = Read_Timer_sync() - tmstart
      frc = peek(00001012h)
    Until ((frc >= 1) Or (tmout > th))
    
    
   
    buf[cnt_i] =Peek(00001010h)
    
   
    th = 5600                                               '  6 mikrosec
  Next cnt_i
  tmstart = Read_Timer_sync()
  Do                                                        ' ack wait
    tmout = Read_Timer_sync() - tmstart                          ' rx count
    frc = Peek(00001012h)
  Until ((frc >= 1) Or (tmout > 4480))                       ' 6 mikrosec '1800
  If (frc >= 1) Then
    nop
    
    ret = Peek(00001010h)
  Else
    ret = -1
  EndIf
  I_Receive = ret
EndFunction

'---------------------------------------------------------------
' Function only For internal use!
' receive LS-Bus
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' value32 : return value (32 bit) 
' return  : error code (0->ok)
'---------------------------------------------------------------
Function I_Receive32(dev_adr, reg_adr,value32) As Long ''<HIDE>
  Dim cnt_i, frc, ftc, tmout, tmstart, th As Long
  
  dim inhelp as long

  do
    ftc = Peek(00001015h)               ' tx FIFO count
  until (ftc < 28)                                          ' platz zum senden
  Sub_begin_critical_section
  Poke(00001010h, (Shift_Left(4 - 1, 4) Or dev_adr))  ' Header 1
  inhelp=0 'nop
  poke(00001010h, reg_adr)              ' Header 2
  Sub_End_critical_section
  io_sleep(20)
    
  Do
    ftc = Peek(00001015h)             ' tx FIFO count
  Until (ftc = 0)
  th = 7228                                                  ' first 6.75 mikrosec
  For cnt_i = 0 To 24 step 8                                     ' data count
    tmstart = Read_Timer_sync()
    Do                                                      ' rx wait
      tmout = Read_Timer_sync() - tmstart
      frc = Peek(00001012h) 
    Until ((frc >= 1) Or (tmout > th))
    
    
   
    inhelp= inhelp or shift_left(Peek(00001010h),cnt_i)
    
   
    th = 4900                                                '  6 mikrosec
  Next cnt_i
  tmstart = Read_Timer_sync()
  value32=inhelp
  Do                                                        ' ack wait
    tmout = Read_Timer_sync() - tmstart                          ' rx count
    frc = Peek(00001012h)
  Until ((frc >= 1) Or (tmout > 4448))                       ' 6 mikrosec '1800
  If (frc >= 1) Then
    I_Receive32 = Peek(00001010h)
  Else
    I_Receive32 = -1
  EndIf
EndFunction

'---------------------------------------------------------------
' Function only For internal use!
' send LS-Bus
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
' return  : error code (0->ok)
'---------------------------------------------------------------
Function I_Send(dev_adr, reg_adr, cnt_dat, buf[]) As Long ''<HIDE>
  Dim cnt_i, frc, ftc, tmout, tmstart As Long
  Dim ret As Long

  Do
    ftc = Peek(00001015h)                ' tx FIFO count
  Until (ftc < (28 - cnt_dat))
  Sub_begin_critical_section
  poke(00001010h, (Shift_Left(cnt_dat - 1, 4) Or dev_adr))  ' Header 1
  
  poke(00001010h, (80h Or reg_adr))     ' Header 2
  
  For cnt_i = 1 To cnt_dat                                  ' data count
    Poke(00001010h, buf[cnt_i])         '
  Next cnt_i
  Sub_End_critical_section
  io_sleep(20)
  Do
    ftc = peek(00001015h)                ' tx FIFO count
  Until (ftc = 0)
  tmstart = Read_Timer_sync()
  Do                                                        ' ack wait
    tmout = Read_Timer_sync() - tmstart
    frc = Peek(00001012h)
  Until ((frc >= 1) Or (tmout > 5600))                       ' 6 mikrosec
  If (frc >= 1) Then
    ret = peek(00001010h)
  Else
    ret = -1
  EndIf
  I_Send = ret
EndFunction


'---------------------------------------------------------------
' Function only For internal use!
' send LS-Bus
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' value   : outvalue 32 bit
' return  : error code (0->ok)
'---------------------------------------------------------------
Function I_Send32(dev_adr, reg_adr, value) As Long ''<HIDE>
  Dim cnt_i, frc, ftc, tmout, tmstart As Long
  Dim ret As Long

  Do
    ftc = Peek(00001015h)                ' tx FIFO count
  Until (ftc < (28 - 4))
  Sub_begin_critical_section
  Poke(00001010h , (Shift_Left(4 - 1, 4) Or dev_adr))  ' Header 1
  nop
  poke(00001010h , (80h Or reg_adr))     ' Header 2
  nop
  For cnt_i = 0 To 24 step 8                                    ' data count
    poke(00001010h, shift_right(value,cnt_i) AND 0FFH)         '
  Next cnt_i
  Sub_End_critical_section
  io_sleep(20)
  Do
    ftc = peek(00001015h)                ' tx FIFO count
  Until (ftc = 0)
  tmstart = Read_Timer_sync()
  Do                                                        ' ack wait
    tmout = Read_Timer_sync() - tmstart
    frc = Peek(00001012h)
  Until ((frc >= 1) Or (tmout > 400))                       ' 6 mikrosec
  If (frc >= 1) Then
    nop
    I_Send32 = Peek(00001010h)
  Else
    I_Send32 = -1
  EndIf
 
EndFunction


'---------------------------------------------------------------
' Function only For internal use!
' send LS-Bus no acknowlege
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
'---------------------------------------------------------------
Sub I_Send_NA(dev_adr, reg_adr, cnt_dat, buf[]) ''<HIDE>
  Dim cnt_i, ftc As Long

  Do
    ftc = Peek(00001015h)                ' tx FIFO count
  Until (ftc < (28 - cnt_dat))
  Sub_begin_critical_section
  Poke(00001010h , (Shift_Left(cnt_dat - 1, 4) Or dev_adr))  ' Header 1
  nop
  poke(00001010h, (80h Or reg_adr))     ' Header 2
  nop
  For cnt_i = 1 To cnt_dat                                  ' data count
    Poke(00001010h, buf[cnt_i])         '
  Next cnt_i
  
  Sub_End_critical_section
EndSub

'---------------------------------------------------------------
' Function only For internal use!
' send LS-Bus no acknowlege
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' value: outvalue
'---------------------------------------------------------------
Sub I_Send_NA32(dev_adr, reg_adr, value) ''<HIDE>
  Dim cnt_i, ftc As Long

  Do
    ftc = Peek(00001015h)                ' tx FIFO count
  Until (ftc < (28 - 4))
  Sub_begin_critical_section
  Poke(00001010h, (Shift_Left(4 - 1, 4) Or dev_adr))  ' Header 1
  nop
  Poke(00001010h, (80h Or reg_adr))     ' Header 2
  nop

  For cnt_i = 0 To 24 step 8                                    ' data count
    Poke(00001010h, shift_right(value,cnt_i) AND 0FFH)         '
  Next cnt_i
  
  
  Sub_End_critical_section
EndSub

'---------------------------------------------------------------
' Function only For internal use!
' send LS-Bus broadcast no acknowlege
' module  : module address
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
'---------------------------------------------------------------
Sub I_Send_BC(reg_adr, cnt_dat, buf[]) ''<HIDE>
  Dim cnt_i, ftc As Long

  Do
    ftc = Peek(00001015h)                ' tx FIFO count
  Until (ftc < (28 - cnt_dat))
  Sub_begin_critical_section
  Poke(00001010h, (Shift_Left(cnt_dat - 1, 4)))  ' Header 1
  nop
  Poke(00001010h, (80h Or reg_adr))     ' Header 2
  nop
  For cnt_i = 1 To cnt_dat
    Poke(00001010h, buf[cnt_i])         ' data count
  Next cnt_i
  Sub_End_critical_section
EndSub

'---------------------------------------------------------------
' Function only For internal use!
' send LS-Bus broadcast no acknowlege (one Byte)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
'---------------------------------------------------------------
Sub I_Send_BC8(reg_adr,value) ''<HIDE>
  Dim ftc As Long

  Do
    ftc = Peek(00001015h)                ' tx FIFO count
  Until (ftc < (28 - 1))
  Sub_begin_critical_section
  Poke(00001010h, (Shift_Left(1 - 1, 4)))  ' Header 1
  nop
  Poke(00001010h , (80h Or reg_adr))     ' Header 2
  nop

  Poke(00001010h , value)         ' data count

  Sub_End_critical_section
EndSub



'---------------------------------------------------------------
' Request to read data
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
'---------------------------------------------------------------
Sub LS_Read_Req(ls_module, reg_adr, cnt_dat) ''<HIDE>
  Dim ftc As Long

  Do
    ftc =Peek(00001015h)                ' tx FIFO count
  Until (ftc < 28)
  Sub_begin_critical_section
  Poke(00001010h , (Shift_Left(cnt_dat - 1, 4) Or ls_module))  'header 1
  nop
  Poke(00001010h, reg_adr)              ' Header 2
  nop
  Sub_End_critical_section
EndSub

'---------------------------------------------------------------
' Read response (only DIG_IO request)
' return  : state of digital outputs and inputs
'---------------------------------------------------------------
Function LS_Read_Resp_DIO() As Long ''<HIDE>
  Dim ld[4] As Long 
  Dim cnt_i As Long

  For cnt_i = 1 To 4                                        ' rx data read
    ld[cnt_i] = Peek(00001010h)          ' rx data read
  Next cnt_i
  LS_Read_Resp_DIO = ld[1] Or (Shift_Left(ld[2], 8)) Or (Shift_Left(ld[3], 16)) Or (Shift_Left(ld[4], 24))
EndFunction

'---------------------------------------------------------------
' Read response
' cnt_dat : count of data  (1..16)
' buf[]   : array (min len is cnt_dat)
' return  : error code (0->ok)
'---------------------------------------------------------------
Function LS_Read_Resp(cnt_dat, buf[]) As Long ''<HIDE>
  Dim cnt_i As Long
  For cnt_i = 1 To cnt_dat                                  ' rx data read
    buf[cnt_i] = Peek(00001010h)         ' rx data read
  Next cnt_i
  LS_Read_Resp = Peek(00001010h)         ' acknowledge
EndFunction

'******************************************************************************
'''Resets the watchdog timer, sets digital outputs and
'''+reads digital inputs.
'''+Return: state of digital outputs and inputs
'''+ ls_module: device nr lsbus (FIX 1)
'''value: each bit corresponds to a channel
'''****************************************************************************
Function LS_Dig_IO(value) As Long

  Dim cnt_i As Long
  dim invalue as long
  invalue=0
  For cnt_i = 0 To 24 step 8           
    invalue=invalue OR Shift_left( Peek(00001010h),cnt_i)          ' rx data read
  Next cnt_i
  LS_Dig_IO = invalue
                                               
  I_Send_BC8(44h, 1) ' WD trigger

  I_Send_NA32(1, 7Ch,value)                         ' channel 1..32
  LS_Read_Req(1, 7Ch, 4)                           ' request new in data
EndFunction

'******************************************************************************
'''Enables, disables and configures the watchdog.
'''+Return: error code (0->ok)
'''ls_module: device nr lsbus (1..15)
'''enable:  
'''+           0->disable
'''+           1->enable
'''time:  trigger time [ms]
'''****************************************************************************
Function LS_Watchdog_Init(ls_module, enable, time) As Long
  Dim ld[2] As Long
  Dim ret, t As Long

  ld[1] = 0ADh   'Watchdog disable
  ld[2] = 0
  ret = I_Send( ls_module, 45h, 2, ld)
  'Watchdog time
  t = time * 40000                                          't = time / 25e-6

  ret = ret Or (I_Send32( ls_module, 48h,t))
  ' Watchdog enable
  ld[1] = 0ADh
  ld[2] = enable And 1
  LS_Watchdog_Init = ret Or (I_Send(ls_module, 45h, 2, ld))
EndFunction

'******************************************************************************
'''Resets the watchdog timer.
'''+If the watchdog is activated, the user program has to call
'''+this Function at least every ....
'''****************************************************************************
Sub LS_Watchdog_Reset()
  I_Send_BC8(44h, 1)
EndSub

'******************************************************************************
'''Initialises a digital I/O module (channel 0 - 31).
'''+Return: error code (0->ok)
'''ls_module: device nr LS-bus (1..15)
'''value: each bit corresponds to 8 channel
'''+           0 -> input
'''+           1 -> output
'''+           bit 0: channels 1..8
'''+               1: channels 9..16
'''+               2: channels 17..24
'''+               3: channels 25..32
'''****************************************************************************
Function LS_DigProg(ls_module, value) As Long
  Dim ld[2] As Long 
  Dim ret As Long

  ld[1] = (Shift_Left(value, 3) And 8h) OR (Shift_Left(value, 7) And 80h) OR 11H
  ld[2] = (Shift_Left(value, 2) And 8h) OR (Shift_Left(value, 6) And 80h) OR 11H
  ret = I_Send(ls_module, 16h, 2, ld)
  ld[1] = (Shift_Left(value, 1) And 8h) Or (Shift_Left(value, 5) And 80h) OR 11H
  ld[2] = (value And 8h) OR (Shift_Left(value, 4) And 80h) OR 11H
  LS_DigProg = ret Or (I_Send(ls_module, 20h + 16h, 2, ld))
EndFunction

'******************************************************************************
'''Sets the digital outputs (channel 0 - 31).
'''ls_module: device nr LS-bus (1..15)
'''value: each bit corresponds to a channel
'''****************************************************************************
Sub LS_Digout_Long(ls_module, value)
  I_Send_NA32(ls_module, 7Ch, value)                 ' channel 1..32
EndSub

'******************************************************************************
'''Sets the digital outputs (channel 0 - 31).
'''ls_module: device nr LS-bus (1..15)
'''value: each bit corresponds to a channel
'''BUS_stat: Error Code 0=OK 
'''****************************************************************************
Sub LS_Digout_Long_BS(ls_module, value,BUS_Stat)
  BUS_Stat=I_Send32(ls_module, 7Ch, value)                 ' channel 1..32
EndSub

'******************************************************************************
'''Reads the digital inputs (channel 0 - 31).
'''+Return: state of digital outputs and inputs
'''ls_module: device nr LS-bus (1..15)
'''****************************************************************************
Function LS_Digin_Long(ls_module) As Long
  Dim ret As Long
  ret = I_Receive32(ls_module, 7Ch,LS_Digin_Long )
EndFunction

'******************************************************************************
'''Reads the digital inputs (channel 0 - 31).
'''+Return: state of digital outputs and inputs
'''ls_module: device nr LS-bus (1..15)
'''BUS_stat: Error Code 0=OK 
'''****************************************************************************
Function LS_Digin_Long_BS(ls_module,BUS_Stat) As Long
  BUS_Stat = I_Receive32(ls_module, 7Ch,LS_Digin_Long_BS)
EndFunction

'******************************************************************************
'''Reads the digital output status (overcurrent) (channel 0 - 31)
'''+Return: each bit corresponds a channel 0 = OK 1 = Error
'''ls_module: device nr lsbus
'''****************************************************************************
Function LS_Get_Output_Status(ls_module) As Long
  Dim t As Long
  t = I_Receive32(ls_module, 50h, LS_Get_Output_Status)
EndFunction

'******************************************************************************
'''Initialises a LS-Module.
'''+Return: error code (0->ok)
'''ls_module: device nr LS-bus (1..15)
'''****************************************************************************
Function LS_DIO_Init(ls_module) As Long
  Dim ld[4] As Long
  Dim ret As Long
  Dim addr As Long
  
  Poke(00001013h, 1)                    ' ' autoreset rx ON
  ld[1] = 3
  ret = I_Send(ls_module, 40h, 1, ld)              ' Reset JX 1, 2
  ld[1] = 1
  ret = ret Or (I_Send(ls_module, 5Ch, 1, ld))     ' timeout reset
  ld[1] = 4
  ret = ret Or (I_Send(ls_module, 4Ch, 1, ld))     ' Set default direction time
  ld[1] = 0
  ld[2] = 0
  ld[3] = 0
  ld[4] = 0
  LS_DIO_Init = ret Or (I_Send(ls_module, 50h, 4, ld))  ' overcurrent reset
  ld[1] = 30h
  LS_DIO_Init = ret Or (I_Send(ls_module, 43h, 1, ld))  ' overtemperature reset
EndFunction

'******************************************************************************
'''Reset the LS - Controller
'''****************************************************************************
SUB LS_Reset() 
  Poke(00001011h, 11B)                    'clear rx und tx
  io_sleep(30)
ENDSUB


'<ENDREGION>

'<REGION> eMMC
#define EMMC_RESERVED_SECTORS 080000h ' 256MB at beginning of eMMC reserved for bootloader usage
#define EMMC_SECTORS_MAX 0070C000h ' size of eMMC is approx 3.6GB
#define EMMC_SECTOR_SIZE 512 ' in bytes
#define EMMC_TRANSACTION_MAX_SECTORS 128 ' maximum number of sectors to be read/written with one library call



Function EMMC_Write_Internal(start_sector, sector_count, source_array[], array_start_index) As Long '<HIDE>
  Dim ValuesPerSector, remaining_sectors, current_sector, current_sector_count, current_array_start_index As Long
  
  ValuesPerSector = EMMC_SECTOR_SIZE / SizeOfArrayElement(source_array)
  remaining_sectors = sector_count
  current_sector = start_sector
  current_array_start_index = array_start_index
  EMMC_Write_Internal = 0
  
#IF DEBUG_MODE = ON THEN 
  If (start_sector + sector_count >= EMMC_SECTORS_MAX) then prozess_fehler = 200410
  If (start_sector < 0) then prozess_fehler = 200411
  System_Array_Debug_Check(source_array, array_start_index, (sector_count * ValuesPerSector))
#endif
  
  Do
    ' write max 128 sectors in each run
    current_sector_count = Min_Long(remaining_sectors, EMMC_TRANSACTION_MAX_SECTORS)

    EMMC_Write_Internal = EMMC_Write_Internal + disk_write_long(0, source_array[current_array_start_index], current_sector, current_sector_count)

    ' update array pointer
    current_array_start_index = current_array_start_index + ValuesPerSector * current_sector_count
    ' update sector pointer
    current_sector = current_sector + current_sector_count
    remaining_sectors = remaining_sectors - current_sector_count
  Until (remaining_sectors <= 0)
EndFunction


'*******************************************************************************
''' Writes values to eMMC.
''' start_sector: EMMC_RESERVED_SECTORS to EMMC_SECTORS_MAX
''' sector_count: Number of sectors to be written. A data blocks contains MEDIA_SECTOR_SIZE bytes.
''' source_array[]: Array from which data is read.
''' array_start_index: Index (1..n) of the first array element to be transferred.
'''*****************************************************************************
Function EMMC_Write(start_sector, sector_count, source_array[], array_start_index) As Long
#IF DEBUG_MODE = ON THEN 
  If (start_sector < EMMC_RESERVED_SECTORS) then prozess_fehler = 200411
#endif
  If (start_sector >= EMMC_RESERVED_SECTORS) Then
    EMMC_Write = EMMC_Write_Internal(start_sector, sector_count, source_array, array_start_index)
  EndIf
EndFunction


'*******************************************************************************
''' Reads values from eMMC.
''' start_sector: EMMC_RESERVED_SECTORS to EMMC_SECTORS_MAX
''' sector_count: Number of sectors to be read. A data blocks contains MEDIA_SECTOR_SIZE bytes.
''' source_array[]: Array to which data is written.
''' array_start_index: Index (1..n) of the first array element to be written.
'''*****************************************************************************
Function EMMC_Read(start_sector, sector_count, source_array[], array_start_index) As Long
  Dim ValuesPerSector, remaining_sectors, current_sector, current_sector_count, current_array_start_index As Long
  
  ValuesPerSector = EMMC_SECTOR_SIZE / SizeOfArrayElement(source_array)
  remaining_sectors = sector_count
  current_sector = start_sector
  current_array_start_index = array_start_index
  EMMC_Read = 0
  
#IF DEBUG_MODE = ON THEN 
  If (start_sector + sector_count >= EMMC_SECTORS_MAX) then prozess_fehler = 200400
  If (start_sector < 0) then prozess_fehler = 200401
  System_Array_Debug_Check(source_array, array_start_index, (sector_count * ValuesPerSector))
#endif
  
  Do
    ' read max 128 sectors in each run
    current_sector_count = Min_Long(remaining_sectors, EMMC_TRANSACTION_MAX_SECTORS)
    EMMC_Read = EMMC_Read + disk_read_long(0, source_array[current_array_start_index], current_sector, current_sector_count)
    ' update array pointer
    current_array_start_index = current_array_start_index + ValuesPerSector * current_sector_count
    ' update sector pointer
    current_sector = current_sector + current_sector_count
    remaining_sectors = remaining_sectors - current_sector_count
  Until (remaining_sectors <= 0)
EndFunction
'<ENDREGION>








