'<ADbasic Header, Headerversion 001.001>
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--ALL
'
'################################################################
'#                           MATH.inc                           #
'#              INCLUDE-file for all ADwin-Systems              #
'################################################################
'#                                                              #
'# Contents: Mathematical FUNCTIONs for processors T9, T10, T11 #
'#                                                              #
'#  12.11.2009  TN   creation (Beta)                            #
'#  02.02.2010  TN   documentation of Mod                       #
'#  25.03.2010  JK   comments  ;  released for ADwin-CD         #
'#  26.01.2011  TN   div_by_10                                  #
'#  19.09.2014  TN   T12                                        #
'#  27.10.2014  JK   div_by_10 for T12                          #
'#                                                              #
'# Attention:                                                   #
'#   - Do not copy the first source line (containing            #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !               #
'#     Otherwise the Syntax color may be not correct.           #
'#                                                              #
'################################################################

#If Processor = T9 Then
Import Math.Li9
#EndIf
#If Processor = T10 Then
Import Math.LiA
#EndIf
#If Processor = T11 Then
Import Math.LiB
#EndIf
#If Processor = T12 Then
Import Math.LiC
#EndIf




' Divides a value by 10. Stores the quotient and the remainder in
' the output parameters.
' see division_strings.doc for a description of the algorithm.
' Time consumption (in cycles), if all parameters are PAR_<x>'s:
' T9   |  T10  |  T11 (Opt.-Level 2)  | T11 (Opt.-Level 0 and 1
' -----+-------+----------------------+--------------------------
' 39 ? | 21 ?  |                      | 18
Sub div_by_10 (dividend, quotient, remainder)
#if prozessor = t11
  dim temp as long
  temp = dividend
  quotient = temp * 0.1
  remainder = temp - quotient * 10
#else
#if prozessor = t12
  dim temp as long
  temp = dividend
  quotient = temp * 0.1
  remainder = temp - quotient * 10
#else
  dim temp as long 
  dim sign_of_result as long 
  dim temp_dividend as long
  
    
  if (dividend < 0) then 
    temp_dividend = -dividend
    sign_of_result = -1
  else
    temp_dividend = dividend
    sign_of_result = 1
  endif
    
  temp = shift_right ((temp_dividend) * 019999999h + shift_right (temp_dividend, 1) + shift_right (temp_dividend, 3), 28)
  remainder = shift_right (10 * (temp + 1), 4)
  quotient = shift_right ((temp_dividend) - remainder, 1) * 0CCCCCCCDh * sign_of_result
#endif
#endif
EndSub


'---------------------------------------------------------------------
'Functions in Library:
'---------------------------------------------------------------------


'Lib_Function Mod(ByVal x_param as Long,ByVal y_param as Long) as Long
'#####################################################################
'#                                                                   #
'#                            r = x Mod y                            #
'#                                                                   #
'#   The modulus determines the signed remainder of x divided by y   #
'#              for nonzero y, and returns x otherwise.              #
'# The function uses the definition of Wirth: the return value of    #
'# the division will be truncated. Therefore Mod(-4,3) returns -1.   #
'#                                                                   #
'# The function Mod() expects LONGs as parameters                    #
'#                                                                   #
'# Known issues:  none                                               #
'#####################################################################





