'<TiCoBasic Header, Headerversion 001.001>
' Foldings                       = 75,232,430,740,1106,1233,1751,1817,2111,2146,2886,2949
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--GOLD
'
'###############################################################
'#                        GOLDIITiCO.inc                       #
'#              INCLUDE-file for ADwin-GOLD-TiCo               #
'###############################################################
'#                                                             #
'# Contents: Include FUNCTIONs for ADwin-GOLD II               #
'#                                                             #
'#  25.09.2007  MF   creation (Beta)                           #
'#  02.10.2007  MF   ADR 08 Fast                               #
'#  05.10.2007  MF   READADC Fast                              #
'#  08.10.2007  MF   DIO ADR Fast                              #
'#  26.11.2007  MF   Digin Fifo                                #
'#  26.11.2007  MF   seq_read                                  #
'#  03.12.2007  MF   CNT_Get_PW_f_dc=>CNT_Get_PW               #
'#  07.12.2007  MF   Event_config                              #
'#  11.01.2008  MF   BUG ADC                                   #
'#  11.01.2008  MF   DAC ADR Fast                              #
'#  21.01.2008  MF   all ADR FAST                              #
'#  28.01.2008  MF   counter                                   #
'#  30.01.2008  MF   anybus/digin_fifo_clear                   #
'#  31.01.2008  MF   En_CAN_Interrupt                          #
'#  01.02.2008  MF   get_digout                                #
'#  01.02.2008  MF   #if adwin_system                          #
'#  06.02.2008  MF   CNT_Get_PW                                #
'#  07.02.2008  MF   Digout_Clear, Digout_Reset                #
'#  04.04.2008  MF   REGION                                    #
'#  15.04.2008  MF   LS-Bus (nop)                              #
'#  17.04.2008  MF   TiCo_Reset_Mode                           #
'#  22.04.2008  MF   Trigger_Event                             #
'#  30.04.2008  MF   Event_config                              #
'#  09.05.2008  MF   ABCC_Reset()                              #
'#  19.05.2008  MF   SEQ                                       #
'#  02.06.2008  MF   CAN LIB Kompatible for JK                 #
'#  06.10.2008  MF   Storage                                   #
'#  13.11.2008  MF   Digin                                     #
'#  18.02.2009  MF/OL Read_Msg_Con                             #
'#  19.02.2009  MF   Transmit_Status                           #     
'#  16.03.2009  MF    '''+                                     #
'#  13.05.2009  MF   optimize CNT_Get_PW, CNT_Get_PW_HL        #
'#  27.05.2009  MF   CNT_Sync_Latch                            #
'#  29.06.2009  MF   '''+ RS_INIT, SEQ_STATUS                  #
'#  10.08.2009  UR   Profibus processarrayelement value        #
'#                   limit to 8bit                             #
'#  05.01.2010  MF   Get_RTC                                   #
'#  22.02.2010  ur   LS-Bus (sleep)                            #
'#  06.04.2010  MF   channel , msg_no () can                   #
'#  01.06.2010  MF   optimize can_init                         #
'#  06.09.2011  mf   write_fifo_full                           #
'#  11.01.2012  mf   bugfix pwm_write_latch                    #
'#  03.02.2012  mf   bugfix pwm_write_latch                    #
'#  30.10.2012  mf   LS Bus (error Code )                      #
'#  04.10.2016  mf   optimize                                  #
'#  04.11.2016  mf   Calc_Processdelay                         #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#                                                             #
'#      Eventsource:                                           #
'#                                                             #
'#      Source DIO edge detection                              #
'#        0E0H DIO rising edge register WITH clear             #
'#        0E2H DIO falling edge register WITH clear            #
'#        0E4H DIO rising edge register WITHOUT clear          #
'#        0E6H DIO falling edge register WITHOUT clear         #
'#      Source Event /or Can                                   # 
'#        0FCH Tico-Event-Register WITH clear                  #
'#        Bit 3=can2, Bit2=can1, bit 1=reserved, Bit 0=event   #
'#        0FEH Tico-Event-Register WITHOUT clear               #
'#        Bit 3=can2, Bit2=can1, bit 1=reserved, Bit 0=event   #
'###############################################################
 
'<REGION> System

#if adwin_system = ADwin_GoldII
#else
#error("This include file can only be used with the ADwin GoldII")  
#endif


#If MAKE_LIB = OFF Then
DIM PWM_Help_mode as Long ''<HIDE>
Dim CAN_msg[9] As Long at dm_local                          ' array with 9 elements
#Endif

'---------------------------------------------------------------
' If a low-priority process accesses must not be
' interrupted by any other process !!!
'---------------------------------------------------------------
Sub Sub_Begin_Critical_Section() ''<HIDE>
#If PRIORITAET = LOW
  Begin_Critical_Section
#EndIf
EndSub

Sub Sub_End_Critical_Section() ''<HIDE>
#If PRIORITAET = LOW
  End_Critical_Section
#EndIf
EndSub


'***************************************************************
''' Converts a process frequency [Hz] into processor ticks (processdelay or cycle time).
''' frequency:  frequency[Hz]
'''*************************************************************
Function Calc_Processdelay(frequency) as long
  
#if prozessor=tico1
  calc_processdelay=50000000/(frequency)
#else
  calc_processdelay=100000000/(frequency)
#endif
  
endfunction
'******************************************************************************
'''Switches CPU LED on or off (stop normal blinking with stop_process(15)).
'''value:     
'''+       0->off 
'''+       1->green
'''+       2->red
'''****************************************************************************
SUB Set_LED(value)
  out(000002FEh, value)
ENDSUB


'******************************************************************************
'''Configures the external event input.
'''min_hold: 
'''+         0->15 ns (default)
'''+         1->50 ns
'''edge: 
'''+         1 rising edge (default)
'''+         2 falling edge
'''+         3 rising & falling edge
'''+         4 disable
'''prescaler: 1..255
'''***************************************************************************
SUB Event_Config(min_hold, edge, prescale)
  out(000000DCh, edge - 1)
  out(000000F8h, min_hold)
  out(000000FAh, prescale)
ENDSUB


'******************************************************************************
'''Resets the watchdog timer.
'''****************************************************************************
Sub Watchdog_Reset()
  out(0000282h, 1)
EndSub


'******************************************************************************
'''Enables, disables and configures the watchdog.
'''onoff: 1 = watchdog enabled 0 = watchdog disabled (default)
'''time: [10 s] 1..0FFFEH 655 ms
'''mode: 
'''+     Bit 0 Reset T11 
'''+     Bit 1 Reset TiCo
'''+     Bit 2 Hardware Output ON                         
'''+     Bit 3 DAC AND DIO to low    
'''****************************************************************************
SUB Watchdog_Init(onoff, time, mode)
  dim value as long
  value = onoff AND 1
  
  if (value = 1) then
    value = value or shift_left((time + 1) AND 0FFFFH, 16) or shift_left(mode AND 1111B, 1)
  endif
  
  out(00000284h, 1)                                         'reset error 
  out(00000280h, value)
  
endsub


'******************************************************************************
'''Sets or resets the watchdog output pin if the watchdog hardware output function is disabled.
'''level: TTL level of the output Watchdog Out:
'''+0: TTL level low
'''+1: TTL level high
'''****************************************************************************
Sub Watchdog_Standby_Value(value)
  out(00000286h, value)                                     'reset error 
endsub


'******************************************************************************
'''Gets the watchdog status.
'''+Bit 0 Watchdog 
'''+             1 = Enable 
'''+             0 = Disable
'''+Bit 1 Status 
'''+             0 =OK     
'''+             1 = Watchdog Alarm
'''****************************************************************************
Function Watchdog_Status() as long                          'error clear by watchdog_init
  Watchdog_Status = in(00000280h)
endfunction

'******************************************************************************
'''Configures TiCo Reset Mode.
'''mode:
'''+0 if T11 booted no reset on TiCo (default)
'''+1 if T11 booted tico stops and starts new if tico running
'''****************************************************************************
SUB TiCo_Reset_Mode(mode)
  out(000002F0h, mode)                                      'reset error 
ENDSUB

'****************************************************************************** 
'Bit:0=0 => TICO wurde nach Power On durch DSP-boot NICHT gestoppt/gestartet
'Bit 0=1 => TICO wurde nach Power On durch DSP-boot gestoppt/gestartet
'****************************************************************************** 
function TiCo_Reset_Source() as long ''<HIDE>
  tico_reset_source = in(2F0H)
endfunction
  
'*******************************************************************************
'''Creates an event for the master cpu.
'''*****************************************************************************
SUB Trigger_Event()
  out (0f0h, 1)
ENDSUB

'<ENDREGION>

'<REGION> DIO

'******************************************************************************
'''Sets the digital outputs (bits 0..15).
'''pattern: each bit corresponds to a channel
'''****************************************************************************
SUB Digout_Word1(pattern)
  out(000000C4h, pattern)
ENDSUB

'******************************************************************************
'''Sets the digital outputs (bits 16..31).
'''pattern: each bit corresponds to a channel
'''****************************************************************************
SUB Digout_Word2(pattern)
  out(000000C6h, pattern)
ENDSUB

'******************************************************************************
'''Sets the digital outputs (bits 0..31).
'''pattern: each bit corresponds to a channel
'''****************************************************************************
SUB Digout_Long(pattern)
  out(000000D2h, pattern)
ENDSUB

'******************************************************************************
'''Reads the digital inputs (channel 0 - 15).
'''****************************************************************************
FUNCTION Digin_Word1() as Long
  digin_word1 = in(000000C0h)
ENDFUNCTION

'******************************************************************************
'''Reads the digital inputs (channel 16 - 31).
'''****************************************************************************
FUNCTION Digin_Word2() as Long
  digin_word2 = in(000000C2h)
ENDFUNCTION

'******************************************************************************
'''Reads the digital inputs (channel 0 - 31).
'''****************************************************************************
FUNCTION Digin_Long() as Long
  digin_Long = in(000000D0h)
ENDFUNCTION

'******************************************************************************
'''Reads the input of one digital input (channel 0 - 31).
'''channel_no: Number (0.31) of digital input.
'''****************************************************************************
FUNCTION Digin(channel_no) as Long
  digin = shift_right(in(000000D0h), channel_no) AND 1
ENDFUNCTION

'******************************************************************************
'''Reads back the output value of the digital outputs (bits 0..15).
'''****************************************************************************
FUNCTION Get_Digout_Word1() AS Long
  NOPS(4) 
  Get_DIGOUT_Word1 = in(000000D4h)
ENDFUNCTION

'******************************************************************************
'''Reads back the output value of the digital outputs (bits 16..31).
'''****************************************************************************
FUNCTION Get_Digout_Word2() AS Long
  NOPS(4)
  Get_DIGOUT_Word2 = in(000000D6h)
ENDFUNCTION

'******************************************************************************
'''Reads back the output value of the digital outputs (bits 0..31).
'''****************************************************************************
FUNCTION Get_Digout_Long() AS Long
  NOPS(4)
  Get_DIGOUT_Long = in(000000D8h)
ENDFUNCTION


'******************************************************************************
'''Configures the digital I/O as inputts or outpu (channels 0 - 31).
'''pattern: each bit corresponds to 8 bit
'''+         0 = input
'''+         1 = output
'''****************************************************************************
SUB Conf_DIO(pattern)
  out(000000DAh, pattern)
  nops(2)
ENDSUB

'******************************************************************************
'''Sets or resets one channel of a digital output.
'''channel: channel (0..31)
'''value: 
'''+    0 = reset channel
'''+    1 = set channel
'''****************************************************************************
SUB Digout(channel, value)
  if ((value) AND 1 = 1) then
    out(000000C8h, shift_left(1, channel))
  else
    out(000000CCh, shift_left(1, channel))
  endif
ENDSUB


'******************************************************************************
'''Sets and resets the selected digital outputs.
'''set:    Bitstring indicating the outputs which should be set (32Bit)
'''clear:  Bitstring indicating the outputs which should be reset (32Bit)
'''****************************************************************************
Sub Digout_Bits(set, clear)
  out(000000C8h, set)
  out(000000Cch, clear)
endsub


'******************************************************************************
'''Sets selected digital outputs.
'''set: Bitstring indicating the outputs which should be set (32Bit)
'''****************************************************************************
Sub Digout_Set(set)
  out(000000C8h, set)
endsub


'******************************************************************************
'''Resets selected digital outputs.
'''clear: Bitstring indicating the outputs which should be reset (32Bit)
'''****************************************************************************
Sub Digout_Reset(clear)
  out(000000Cch, clear)
endsub


'******************************************************************************
'''Clears the digin fifo.
'''****************************************************************************
SUB Digin_FIFO_Clear()
  out(000000E8h, 0)
  nops(4)
ENDSUB


'******************************************************************************
'''Gets the digin fifo timer.
'''****************************************************************************
FUNCTION Digin_FIFO_Read_Timer() as Long
  Digin_FIFO_Read_Timer = in(000000ECh)
ENDFUNCTION

'******************************************************************************
'''Determines which input channels will be monitores by the edge detection unit.
'''pattern: each bit corresponds to a channel
'''****************************************************************************
SUB Digin_FIFO_Enable(pattern)
  out(000000EAh, pattern)
ENDSUB


'******************************************************************************
'''Gets the digin fifo values count.
'''****************************************************************************
FUNCTION Digin_FIFO_Full() as Long
  Digin_FIFO_Full = IN(000000E8h) AND 0FFFFH
ENDFUNCTION


'******************************************************************************
'''Reads timestamps and input values from digin fifo.
'''value_by_ref: input values
'''timestamp_by_ref: associated timestamp values
'''****************************************************************************
SUB Digin_FIFO_Read(value_by_ref, timestamp_by_ref)
  SUB_BEGIN_CRITICAL_SECTION
  value_by_ref = IN(000000EEh)
  timestamp_by_ref = IN(000000EEh)
  SUB_END_CRITICAL_SECTION
ENDSUB

'******************************************************************************
'''Reads digin edge.
'''+read value => reset the bits
'''+result: 
'''+        0->activated
'''+        1->deactivated
'''+activated = a x edge has been received
'''edge: 
'''+     0->neg edge
'''+     1->pos edge
'''****************************************************************************
Function Digin_Edge(edge) as Long
  Digin_Edge = IN(000000E2h - 2 * (edge))
EndFunction

'<ENDREGION>

'<REGION> Analog

'******************************************************************************
'''Sets MUX to desired input channel.
''' pattern: bit 4 & 3 -> gain, bit 2...0 ->
'''+                                          000 channel 1
'''+                                          001 channel 3
'''+                                          010 channel 5
'''+                                          011 channel 7
'''+                                          100 channel 9
'''+                                          101 channel 11
'''+                                          110 channel 13
'''+                                          111 channel 15
'''****************************************************************************
SUB Set_Mux1(value)
  out(00000000h, value)
ENDSUB


'******************************************************************************
'''Sets MUX to desired input channel.
''' pattern: bit 4 & 3 -> gain, bit 2...0 ->
'''+                                          000 channel 2
'''+                                          001 channel 4
'''+                                          010 channel 6
'''+                                          011 channel 8
'''+                                          100 channel 10
'''+                                          101 channel 12
'''+                                          110 channel 14
'''+                                          111 channel 16
'''******************************************************************************
SUB Set_Mux2(value)
  out(00000002h, value)
ENDSUB


'******************************************************************************
'''Waits until EOC-signals of all selected ADCs are active.
'''pattern: ADC-#1 -> bit 0, ..., ADC-#2 -> bit 1
'''****************************************************************************
SUB Wait_EOC(pattern)
  Dim reminder as Long

  nops(4)


  do
    reminder = in(00000008h) and (pattern)
  until (reminder = 0)
ENDSUB


'******************************************************************************
'''Starts a conversion on selected ADC.
'''pattern: databits, by example: 011B = ADC1+2
'''****************************************************************************
SUB Start_Conv(pattern)
  out(00000004h, (pattern) XOR 11111B)
ENDSUB


'******************************************************************************
'''Returns conversion result of ADC.
'''+result: 16 bit Long
'''ADC_No: adc number (1 or 2)
'''****************************************************************************
FUNCTION Read_ADC(ADC_no) as Long
  if (ADC_no = 1) then
    Read_ADC = in(00000010h)
  else
    Read_ADC = in(00000012h)
  endif

ENDFUNCTION


'******************************************************************************
'''Returns conversion result of ADC.
'''+result: 24 bit Long
'''ADC_No: adc number (1 or 2)
'''****************************************************************************
FUNCTION Read_ADC24(ADC_no) as Long
  if (ADC_no = 1) then
    Read_ADC24 = in(00000014h)
  else
    Read_ADC24 = in(00000016h)
  endif
ENDFUNCTION


'******************************************************************************
'''Samples, converts and reads out the digital 16 bit ADC-value.
'''+Attention:                                                 
'''+This instruction is not prepared to handle an access from  
'''+a low AND high priority process.     
'''+result: 16 bit Long
'''channel: channel number of analog input
'''****************************************************************************
FUNCTION ADC(channel) as Long

  dim m as Long

  dim pattern as long


  pattern = 1


  if ((channel) AND 1 > 0) then                             'ungerade
    m = (channel - 1) / 2
    out(00000000h, m)                                       'setmux
    sleep(20)                                               '2 s
    out(00000004h, 0EH)                                     'start_conv

    nop                                                     'wait_eoc
    nop
    nop
    nop



    do
      m = IN(00000008h) and (1)
    until (m = 0)

    ADC = IN(00000010h)
  else                                                      'gerade
    m = ((channel) / 2) - 1
    out(00000002h, m)                                       'setmux
    sleep(20)                                               '2 s
    out(00000004h, 0DH)                                     'start_conv

    nop
    nop
    nop
    nop

    do                                                      'wait_eoc
      m = IN(00000008h) and 2
    until (m = 0)

    ADC = in(00000012h)
  endif


ENDFUNCTION


'******************************************************************************
'''Samples, converts and reads out the digital 18 bit ADC-value
'''+Attention:                                                 
'''+This instruction is not prepared to handle an access from  
'''+a low AND high priority process.        
'''+result: 24 bit Long
'''channel: channel number of analog input
'''****************************************************************************
FUNCTION ADC24(channel) as Long

  dim m as Long

  if ((channel) AND 1 > 0) then                             'ungerade
    m = (channel - 1) / 2
    out(00000000h, m)                                       'setmux
    sleep(20)                                               '2 s
    out(00000004h, 0EH)                                     'start_conv

    nop
    nop
    nop
    nop

    do
      m = in(00000008h) and 1
    until (m = 0)

    ADC24 = in(00000014h)
  else                                                      'gerade
    m = ((channel) / 2) - 1
    out(00000002h, m)                                       'setmux
    sleep(20)                                               '2 s
    out(00000004h, 0DH)                                     'start_conv


    nop
    nop
    nop
    nop


    do                                                      'wait_eoc
      m = in(00000008h) and 2
    until (m = 0)

    ADC24 = in(00000016h)
  endif

ENDFUNCTION

'******************************************************************************
'''Converts the digitial value to an analog output.
'''dac_no: channel number of analog output
'''value: output value (0..65535)
'''****************************************************************************
SUB DAC(dac_no, value)
  out(0000002Eh + (DAC_No) * 2, value)
ENDSUB

'******************************************************************************
'''Sets DAC-register to desired value.
'''nr: channel number of analog output
'''value: output value (0..65535)
'''****************************************************************************
SUB Write_DAC(dac_no, value)
  out(0000001Eh + (dac_no) * 2, value)
ENDSUB


'******************************************************************************
'''Simultaneously start conversion of all DACs.
'''****************************************************************************
SUB Start_DAC()
  out(00000004h, 0fbh)
ENDSUB

'******************************************************************************
'''Reads the input data in seq mode.
'''+return 16 Bit ADC value
'''channel: 1-16
'''****************************************************************************
FUNCTION SEQ_Read(channel) as Long
  SEQ_Read = IN(000004FEh + (channel) * 2)
ENDFUNCTION


'******************************************************************************
'''Reads the status of the seq state machine.
'''+0: Single conversion cycle is completed.
'''+1: Single conversion cycle is not yet completed
'''adc_no: 
'''+       1  for channel 1, 3, 5, 7, 9, 11, 13, 15
'''+       2  for channel 2, 4, 6, 8, 10, 12, 14, 16
'''****************************************************************************
FUNCTION SEQ_Status(adc_no) as Long
  dim h as long
  nops(4)
  h = in(00000550h)
  SEQ_STATUS = shift_right(h, adc_no - 1) AND 1
ENDFUNCTION

'******************************************************************************
'''Set the mux settling time of the seq state machine.
'''adc_no:
'''+       1  for channel 1, 3, 5, 7, 9, 11, 13, 15
'''+       2  for channel 2, 4, 6, 8, 10, 12, 14, 16
'''mux_time: default    unit 20 ns
'''****************************************************************************
SUB SEQ_Set_Delay(adc_no, mux_time)
  out(0000053Eh + (adc_no) * 2, mux_time)
ENDSUB

'******************************************************************************
'''Sets the gain of the seq state machine.
'''adc_no: 
'''+       1  for channel 1, 3, 5, 7, 9, 11, 13, 15
'''+       2  for channel 2, 4, 6, 8, 10, 12, 14, 16
'''gain:  
'''+       0 = factor 1
'''+       1 = factor 2
'''+       2 = factor 4
'''+       3 = factor 8
'''****************************************************************************
SUB SEQ_Set_Gain(adc_no, gain)
  out(00000542h + (adc_no) * 2, gain)
ENDSUB

'******************************************************************************
'''Selects the channel in single shot or continuous mode.
'''pattern: selected channels in binary
'''****************************************************************************
Sub SEQ_Select(pattern)
  out(00000530h, pattern)
Endsub


'******************************************************************************
'''Initializes the ain mode.
'''adc_no: 
'''+        1  for channel 1, 3, 5, 7, 9, 11, 13, 15
'''+        2  for channel 2, 4, 6, 8, 10, 12, 14, 16
''' mode:   
'''+        0 normal mode (seq off)
'''+        1 single shot mode
'''+        2 continuous mode
'''****************************************************************************
Sub SEQ_Mode(adc_no, mode)
  out(0000051Eh + (adc_no) * 2, mode)
ENDsub

'******************************************************************************
'''Start the seq state machine for seleted ADCs
'''pattern: bit pattern to select ADC
'''+ bit 0: ADC 1 for channel 1, 3, 5, 7, 9, 11, 13, 15
'''+ bit 1: ADC 2 for channel 2, 4, 6, 8, 10, 12, 14, 16
'''****************************************************************************
SUB SEQ_Start(pattern)
  out(00000550h, pattern)
ENDSUB

'<ENDREGION>

'<REGION> CNT

#If MAKE_LIB = ON Then
'******************************************************************************
'''Sets modE for counter.
'''channel: number of the counter
'''mode:
'''+   Bit 0 CNT MODE
'''+           0->TAKT/Richtung
'''+           1->AB
'''+   Bit 1 CLEAR MODE
'''+           0->normal mode
'''+           1->clear IF A=1 B=1 C=1
'''+   Bit 2 INV CLK
'''+           0->not inverse
'''+           1->inverse
'''+   Bit 3 INV DIR
'''+           0->not inverse
'''+           1->inverse
'''+   Bit 4 CLEAR or LATCH
'''+           0->C use for clear
'''+           1->C use for latch
'''+   Bit 5 Ext Clear/Latch Enable
'''+           0=disable
'''+           1=enable
'''+   Bit 6 PWM reference edge
'''+           0->positive
'''+           1->negative
'''+   Bit 7, 8 PWM INPUT_SELECT
'''+           00->A
'''+           01->B
'''+           10->C
'''****************************************************************************
SUB CNT_Mode(channel, mode, PWM_help_mode) ''<HIDE>
  DIM modei as Long
  out(00000046h + (channel) * 2, mode)
  modei = shift_right(mode, 6) AND 1
  PWM_help_mode = ((NOT (shift_left(1, channel - 1))) AND PWM_help_mode) OR shift_left(modei, channel - 1)
ENDSUB
#else

'******************************************************************************
'''Sets mode for counter.
'''channel: number of the counter
'''mode:
'''+   Bit 0 CNT MODE
'''+           0->TAKT/Richtung
'''+           1->AB
'''+   Bit 1 CLEAR MODE
'''+           0->normal mode
'''+           1->clear IF A=1 B=1 C=1
'''+   Bit 2 INV CLK
'''+           0->not inverse
'''+           1->inverse
'''+   Bit 3 INV DIR
'''+           0->not inverse
'''+           1->inverse
'''+   Bit 4 CLEAR or LATCH
'''+           0->C use for clear
'''+           1->C use for latch
'''+   Bit 5 Ext Clear/Latch Enable
'''+           0=disable
'''+           1=enable
'''+   Bit 6 PWM reference edge
'''+           0->positive
'''+           1->negative
'''+   Bit 7, 8 PWM INPUT_SELECT
'''+           00->A
'''+           01->B
'''+           10->C
'''****************************************************************************
SUB CNT_Mode(channel, mode)
  DIM modei as Long
  out(00000046h + (channel) * 2, mode)
  modei = shift_right(mode, 6) AND 1
  PWM_help_mode = ((NOT (shift_left(1, channel - 1))) AND PWM_help_mode) OR shift_left(modei, channel - 1)
ENDSUB
#endif

'******************************************************************************
'''Activates or deactivates counter.
'''pattern: Bit 0-3 VR counter Enable Bit 8-11 PW Counter Enable
'''****************************************************************************
SUB CNT_Enable(pattern)
  OUT(00000040h, pattern)
ENDSUB

'******************************************************************************
'''Latches vr-counter to vr-latch.
'''pattern: each bit corresponds to a counter
'''****************************************************************************
SUB CNT_Latch(pattern)
  OUT(00000042h, (pattern) AND 0FH)
  nops(4)
ENDSUB

'******************************************************************************
'''Reads vr-latch register.
'''channel: number of the counter
'''****************************************************************************
FUNCTION CNT_Read_Latch(channel) as Long
  CNT_READ_LATCH = in(0000010Ch + (channel - 1) * 32)
ENDFUNCTION

'******************************************************************************
'''Latches vr-counter to vr-latch and read vr-latch register (counter value).
'''channel: number of the counter
'''****************************************************************************
FUNCTION CNT_Read(channel) as Long
  OUT(00000042h, shift_left(1, channel - 1))
  nops(4)
  CNT_READ = in(0000010Ch + (channel - 1) * 32)
ENDFUNCTION

'******************************************************************************
'''Clears counter.
'''pattern: each bit corresponds to a counter
'''****************************************************************************
SUB CNT_Clear(pattern)
  OUT(00000042h, shift_left(pattern, 8) AND 0FF00H)
ENDSUB


'******************************************************************************
'''Reads the status of a counter input.
'''+ return:
'''+Bit 0= A Input
'''+Bit 1= B Input
'''+Bit 2= C/L Input
'''+Bit 3=Cable error
'''+Bit 4=Phase error
''' channel: number of the counter
'''****************************************************************************
FUNCTION CNT_Get_Status(channel) as Long
  CNT_Get_Status = In(0000011Eh + (channel - 1) * 32)
ENDFUNCTION

'******************************************************************************
'''Returns the content of a counter register.
'''channel: Counter number: 1.4.
'''regnr= 0 pos_pwm_latch 1
'''+        1 pos_pwm_latch 2
'''+        2 pos_pwm_latch 3
'''+        3 neg_pwm_latch 1
'''+        4 neg_pwm_latch 2
'''+        5 neg_pwm_latch 3
'''+        6 vr latch
'''+        7 pwm latch shadow
'''+        8 pos_pwm_latch 1 shadow
'''+        9 pos_pwm_latch 2 shadow
'''+        10 pos_pwm_latch 3 shadow
'''+        11 neg_pwm_latch 1 shadow
'''+        12 neg_pwm_latch 2 shadow
'''+        13 neg_pwm_latch 3 shadow
'''+        14 vr_latch shadow
'''+        15 status
'''****************************************************************************
FUNCTION CNT_Read_Int_Register(channel, regnr) as Long
  CNT_READ_INT_Register = In(00000100h + (regnr) * 2 + (channel - 1) * 32)
ENDFUNCTION


'******************************************************************************
'''Copys pw-latches and vr-latches to shadow register.
'''pattern: each bit corresponds to a counter
'''****************************************************************************
SUB CNT_PW_Latch(pattern)
  out(00000042h, shift_left((pattern) AND 0FFH, 24))
  nops(4)
ENDSUB

'******************************************************************************
'''Does two steps (at one timestep):
'''+1. latches vr-counter to vr-latch
'''+2. copys pw-latches and vr-latches to shadow registers
'''pattern: each bit corresponds to a counter
'''****************************************************************************
SUB CNT_Sync_Latch(pattern)
  out (00000042h, (pattern AND 0FH) or (shift_left((pattern) AND 0FH, 24)))
  nops(4)
ENDSUB


'******************************************************************************
'''Selects single-ended (s.e.) or differential (diff.) inputs.
'''select: s.e. -> 0 (default after power-up), diff. -> 1
'''+counter 1  selected with Bit 0
'''+counter 2  selected with Bit 1
'''+counter 3  selected with Bit 2
'''+counter 4  selected with Bit 3
'''****************************************************************************
SUB CNT_SE_Diff(select)
  out(00000044h, select)
ENDSUB

'**************************************************************
'Reads pw frequency and dutycycle use cnt_pw_latch before
'by val channel
'by ref frequency as long
'by ref dutyCycle as long
'**************************************************************

#If MAKE_LIB = OFF Then
SUB CNT_Get_PW(channel, frequency, dutyCycle) ''<HIDE> use CNT_GET_PW_HL from TiCo

  DIM pos2 as Long
  DIM pos3 as Long
  DIM neg2 as Long
  DIM neg3 as Long

  DIM period as Long
  DIM puls as Long
  DIM ref_edge as Long
  

 
  pos3 = in(00000114h + (channel - 1) * 32)
  neg3 = in(0000011Ah + (channel - 1) * 32)
  '
  ref_edge = shift_right(PWM_help_mode, channel - 1) AND 1
  '
  IF (ref_edge = 1) then                                    'negative referenz edge
    neg2 = in(00000118h + (channel - 1) * 32)
    period = neg2 - neg3
    puls = neg2 - pos3
  ELSE                                                      'positive referenz edge
    pos2 = in(00000112h + (channel - 1) * 32)
    period = pos2 - pos3
    puls = neg3 - pos3
  ENDIF
  '
  if (period <> 0) then
    frequency = 100000000 / (period)                        'Frequenz [Hz] '100 MHz
    dutyCycle = puls * 100 / (period)                       'PWM Verhltnis
  else 
    frequency = 0
    dutyCycle = 0
  endif
  

  
ENDSUB
#else
SUB CNT_Get_PW(channel, frequency, dutyCycle, PWM_help_mode) ''<HIDE> use CNT_GET_PW_HL from TiCo

  DIM pos2 as Long
  DIM pos3 as Long
  DIM neg2 as Long
  DIM neg3 as Long

  DIM period as Long
  DIM puls as Long
  DIM ref_edge as Long
  

  pos3 = in(00000114h + (channel - 1) * 32)
  neg3 = in(0000011Ah + (channel - 1) * 32)
  '
  ref_edge = shift_right(PWM_help_mode, channel - 1) AND 1
  '
  IF (ref_edge = 1) then                                    'negative referenz edge
    neg2 = in(00000118h + (channel - 1) * 32)
    period = neg2 - neg3
    puls = neg2 - pos3
  ELSE                                                      'positive referenz edge
    pos2 = in(00000112h + (channel - 1) * 32)
    period = pos2 - pos3
    puls = neg3 - pos3
  ENDIF
  '
  if (period <> 0) then
    frequency = 100000000 / (period)                        'Frequenz [Hz] '100 MHz
    dutyCycle = puls * 100 / (period)                       'PWM Verhltnis
  else 
    frequency = 0
    dutyCycle = 0
  endif
  

  
ENDSUB

#endif


#If MAKE_LIB = OFF Then

'******************************************************************************
'''Reads registers and calculates pw hightime and lowtime.
'''+Remark: use cnt_pw_latch before (to get actual values)
'''channel: Counter number: 1.4.
'''hightime: Pulse duration in units of 10 ns: high level time of PWM signal.
'''+by ref  as Long
'''lowtime: Pulse period in units of 10 ns:.0): low level time of PWM signal.
'''+by ref  as Long
'''****************************************************************************
SUB CNT_Get_PW_HL(channel, HighTime, LowTime)

  DIM pos2 as Long
  DIM pos3 as Long
  DIM neg2 as Long
  DIM neg3 as Long

  DIM period as Long
  DIM puls as Long
  DIM paus as Long
  DIM ref_edge as Long


  pos3 = in(00000114h + (channel - 1) * 32)
  neg3 = in(0000011Ah + (channel - 1) * 32)

  ref_edge = shift_right(PWM_help_mode, channel - 1) AND 1

  IF (ref_edge = 1) then                                    'negative referenz edge
    neg2 = in(00000118h + (channel - 1) * 32)
    period = neg2 - neg3
    puls = neg2 - pos3
    paus = pos3 - neg3
  ELSE                                                      'positive referenz edge
    pos2 = in(00000112h + (channel - 1) * 32)
    period = pos2 - pos3
    puls = neg3 - pos3
    paus = pos2 - neg3
  ENDIF
  hightime = puls
  lowtime = paus
ENDSUB
#else
SUB CNT_Get_PW_HL(channel, HighTime, LowTime, PWM_help_mode) ''<HIDE>

  DIM pos2 as Long
  DIM pos3 as Long
  DIM neg2 as Long
  DIM neg3 as Long

  DIM period as Long
  DIM puls as Long
  DIM paus as Long
  DIM ref_edge as Long


  pos3 = in(00000114h + (channel - 1) * 32)
  neg3 = in(0000011Ah + (channel - 1) * 32)

  ref_edge = shift_right(PWM_help_mode, channel - 1) AND 1

  IF (ref_edge = 1) then                                    'negative referenz edge
    neg2 = in(00000118h + (channel - 1) * 32)
    period = neg2 - neg3
    puls = neg2 - pos3
    paus = pos3 - neg3
  ELSE                                                      'positive referenz edge
    pos2 = in(00000112h + (channel - 1) * 32)
    period = pos2 - pos3
    puls = neg3 - pos3
    paus = pos2 - neg3
  ENDIF
  hightime = puls
  lowtime = paus
ENDSUB

#endif

'<ENDREGION>

'<REGION> PWM OUTPUT

'******************************************************************************
'Setzt den Ausgang auf Low oder High wenn der PWM Modus fr den Kanal nicht aktiv ist
'Gleichzeitig ist dies der Zustand der gesetzt wird nach dem die PWM Ausgabe sich stoppt oder gestoppt wird.
'''Set output to low or high if pwm mode for this channel off.
'''value:
'''+ 0: output low
'''+ 1: output high
'''+ one bit per channel
'''****************************************************************************
SUB PWM_Standby_Value(value)
  out(00000304h, value)
ENDSUB


'******************************************************************************
'''Enables an output of the PWM module.
'''pattern: each bit corresponds to a counter 
'''+ 0: disable 
'''+ 1: enable
'''****************************************************************************
SUB PWM_Enable(value)
  out(00000300h, value)
ENDsub

'******************************************************************************
'''Stops the output of one or more PWM outputs immediately.
'''value:
'''+ 0: No influence
'''+ 1: PWM Stop output immediately
'''****************************************************************************
SUB PWM_Reset(value)
  out(00000308h, value)
ENDSUB

'******************************************************************************
'''Sets the defaults for one PWM output.
'''channel: number (1..6) of PWM output.
'''startdelay: Start delay in units of 20 ns.
'''startvalue: Start level of PWM output:
'''mode: Operating mode of PWM outputs as bit pattern (bits 0..2 only).
'''+Bit 0: Moment to take over a new PW frequency:
'''+     Bit = 0: Take over at end of period.
'''+     Bit = 1: Take over immediately.
'''+Bit 1: Number of pulses:
'''+     Bit = 0: infinite number of pulses.
'''+     Bit = 1: number of pulses is count.
'''+Bit 2: Moment to stop after stop instruction:
'''+     Bit = 0: Stop at end of period.
'''+     Bit = 1: Stop immediately.
'''count: Number of periods (1.32 768), which are processed during an output cycle
'''****************************************************************************
SUB PWM_Init(channel, startdelay, startvalue, mode, count)
  DIM old as Long
  DIM maske as Long
  DIM maske2 as Long
  out(0000033Eh + (channel) * 2, startdelay)
  out(0000032Eh + (channel) * 2, count)
  out(0000034Eh + (channel) * 2, mode)

  maske = shift_left(1, channel - 1)
  maske2 = maske XOR 11111111B
  'startvalue
  old = IN(00000302h) AND maske2
  old = old or shift_left((startvalue) AND 1, channel - 1)
  out(00000302h, old)
ENDSUB

'******************************************************************************
'''Writes dutycycle and frequency to latch register.
'''channel: number (1..6) of PWM output.
'''DutyCycle: 0 .. 100 %
'''frequency: 1 .. 50000000 Hz
'''****************************************************************************
SUB PWM_Write_Latch(channel, DutyCycle, frequency)
  DIM max as Long
  DIM low as Long
  DIM per as long
  
  dim maxsmall as long
  'max=100000000/frequency 'ref 100 MHz
  max = 50000000 / (frequency)                              'ref 50 MHz
  
  out(0000031Eh + channel * 2, max - 1)
  
  
  
  maxsmall=max/100
  
  per = DutyCycle

  IF (per < 0) then per = 0
 
  if (maxsmall>100000) then
    low = maxsmall * per 
  else
    low=max*per/100
  endif
 
  if (max <= low) then low = max - 1                        'IF (per>100) then per=100

  out(0000030Eh + (channel) * 2, low - 1)

ENDSUB

'******************************************************************************
'''Latches frequency and dutycyle register to pwm state machine.
'''pattern: bit pattern to select PWM outputs
'''+Bit = 0: No influence.
'''+Bit = 1: latch = enable for output.
'''****************************************************************************
SUB PWM_Latch(pattern)
  out(00000306h, pattern)
  nops(3)
ENDSUB

'******************************************************************************
'''Reads the status of the pwm state machine.
'''+return: 0 stop 1 run (each channel one bit)
'''****************************************************************************
FUNCTION PWM_Get_Status() as Long
  PWM_Get_Status = IN(00000300h)
ENDFUNCTION

'<ENDREGION>

'<REGION> LS-BUS

'---------------------------------------------------------------
' Function only For internal use!
' receive LS-Bus
' channel : number of the LS interface on the LS module
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
' return  : error code (0->ok)
'---------------------------------------------------------------
Function I_Receive(channel, dev_adr, reg_adr, cnt_dat, buf[]) As Long ''<HIDE>
  Dim cnt_i, frc, ftc, tmout, tmstart, th As Long
  Dim ret As Long

  do
    ftc = IN(00000386h + (channel - 1) * 32)                ' tx FIFO count
  until (ftc < 28)                                          ' platz zum senden
  Sub_begin_critical_section
  out(00000380h + (channel - 1) * 32, (Shift_Left(cnt_dat - 1, 4) Or dev_adr))  ' Header 1
  nop
  out(00000380h + (channel - 1) * 32, reg_adr)              ' Header 2
  Sub_End_critical_section
  sleep(2)
  Do
    ftc = IN(00000386h + (channel - 1) * 32)                ' tx FIFO count
  Until (ftc = 0)
  th = 520                                                  ' first 6.75 mikrosec
  For cnt_i = 1 To cnt_dat                                  ' data count
    tmstart = Read_Timer()
    Do                                                      ' rx wait
      tmout = Read_Timer() - tmstart
      frc = IN(00000384h + (channel - 1) * 32)
    Until ((frc >= 1) Or (tmout > th))
    buf[cnt_i] = IN(00000380h + (channel - 1) * 32)
    th = 350                                                '  6 mikrosec
  Next cnt_i
  tmstart = Read_Timer()
  Do                                                        ' ack wait
    tmout = Read_Timer() - tmstart                          ' rx count
    frc = in(00000384h + (channel - 1) * 32)
  Until ((frc >= 1) Or (tmout > 320))                       ' 6 mikrosec '1800
  If (frc >= 1) Then
    ret = IN(00000380h + (channel - 1) * 32)
  Else
    ret = -1
  EndIf
  I_Receive = ret
EndFunction


'---------------------------------------------------------------
' Function only For internal use!
' receive LS-Bus
' channel : number of the LS interface on the LS module
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' value32  : invalue
' return  : error code (0->ok)
'---------------------------------------------------------------
Function I_Receive32(channel, dev_adr, reg_adr, value32) As Long ''<HIDE>
  Dim cnt_i, frc, ftc, tmout, tmstart, th As Long

  dim help as long
  
  do
    ftc = IN(00000386h + (channel - 1) * 32)                ' tx FIFO count
  until (ftc < 28)                                          ' platz zum senden
  Sub_begin_critical_section
  out(00000380h + (channel - 1) * 32, (Shift_Left(4 - 1, 4) Or dev_adr))  ' Header 1
  help=0 'nop
  out(00000380h + (channel - 1) * 32, reg_adr)              ' Header 2
  Sub_End_critical_section
  sleep(2)
  
  Do
    ftc = IN(00000386h + (channel - 1) * 32)                ' tx FIFO count
  Until (ftc = 0)
  th = 520                                                  ' first 6.75 mikrosec
  For cnt_i = 0 To 24 step 8                                   ' data count
    tmstart = Read_Timer()
    Do                                                      ' rx wait
      tmout = Read_Timer() - tmstart
      frc = IN(00000384h + (channel - 1) * 32)
    Until ((frc >= 1) Or (tmout > th))
    help= help or shift_left(IN(00000380h + (channel - 1) * 32),cnt_i)
    th = 350                                                '  6 mikrosec
  Next cnt_i
  tmstart = Read_Timer()
  value32=help
  Do                                                        ' ack wait
    tmout = Read_Timer() - tmstart                          ' rx count
    frc = in(00000384h + (channel - 1) * 32)
  Until ((frc >= 1) Or (tmout > 320))                       ' 6 mikrosec '1800
  If (frc >= 1) Then
    I_Receive32 = IN(00000380h + (channel - 1) * 32)
  Else
    I_Receive32 = -1
  EndIf

EndFunction
'---------------------------------------------------------------
' Function only For internal use!
' send LS-Bus
' channel : number of the LS interface on the LS module
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
' return  : error code (0->ok)
'---------------------------------------------------------------
Function I_Send(channel, dev_adr, reg_adr, cnt_dat, buf[]) As Long ''<HIDE>
  Dim cnt_i, frc, ftc, tmout, tmstart As Long
  Dim ret As Long

  Do
    ftc = IN(00000386h + (channel - 1) * 32)                ' tx FIFO count
  Until (ftc < (28 - cnt_dat))
  Sub_begin_critical_section
  out(00000380h + (channel - 1) * 32, (Shift_Left(cnt_dat - 1, 4) Or dev_adr))  ' Header 1
  nop
  out(00000380h + (channel - 1) * 32, (80h Or reg_adr))     ' Header 2
  nop
  For cnt_i = 1 To cnt_dat                                  ' data count
    out(00000380h + (channel - 1) * 32, buf[cnt_i])         '
  Next cnt_i
  Sub_End_critical_section
  sleep(2)
  Do
    ftc = IN(00000386h + (channel - 1) * 32)                ' tx FIFO count
  Until (ftc = 0)
  tmstart = Read_Timer()
  Do                                                        ' ack wait
    tmout = Read_Timer() - tmstart
    frc = IN(00000384h + (channel - 1) * 32)
  Until ((frc >= 1) Or (tmout > 400))                       ' 6 mikrosec
  If (frc >= 1) Then
    ret = IN(00000380h + (channel - 1) * 32)
  Else
    ret = -1
  EndIf
  I_Send = ret
EndFunction

'---------------------------------------------------------------
' Function only For internal use!
' send LS-Bus
' channel : number of the LS interface on the LS module
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' value   : outvalue 
' return  : error code (0->ok)
'---------------------------------------------------------------
Function I_Send32(channel, dev_adr, reg_adr, value) As Long ''<HIDE>
  Dim cnt_i, frc, ftc, tmout, tmstart As Long

  Do
    ftc = IN(00000386h + (channel - 1) * 32)                ' tx FIFO count
  Until (ftc < (28 - 4))
  Sub_begin_critical_section
  out(00000380h + (channel - 1) * 32, (Shift_Left(4 - 1, 4) Or dev_adr))  ' Header 1
  nop
  out(00000380h + (channel - 1) * 32, (80h Or reg_adr))     ' Header 2
  nop
  For cnt_i = 0 To 24 step 8                                 ' data count
    out(00000380h + (channel - 1) * 32, shift_right(value,cnt_i) AND 0FFH)  '
  Next cnt_i
  Sub_End_critical_section
  sleep(2)
  Do
    ftc = IN(00000386h + (channel - 1) * 32)                ' tx FIFO count
  Until (ftc = 0)
  tmstart = Read_Timer()
  Do                                                        ' ack wait
    tmout = Read_Timer() - tmstart
    frc = IN(00000384h + (channel - 1) * 32)
  Until ((frc >= 1) Or (tmout > 400))                       ' 6 mikrosec
  If (frc >= 1) Then
    I_Send32 = IN(00000380h + (channel - 1) * 32)
  Else
    I_Send32 = -1
  EndIf

EndFunction

'---------------------------------------------------------------
' Function only For internal use!
' send LS-Bus no acknowlege
' channel : number of the LS interface on the LS module
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
'---------------------------------------------------------------
Sub I_Send_NA(channel, dev_adr, reg_adr, cnt_dat, buf[]) ''<HIDE>
  Dim cnt_i, ftc As Long

  Do
    ftc = IN(00000386h + (channel - 1) * 32)                ' tx FIFO count
  Until (ftc < (28 - cnt_dat))
  Sub_begin_critical_section
  out(00000380h + (channel - 1) * 32, (Shift_Left(cnt_dat - 1, 4) Or dev_adr))  ' Header 1
  nop
  out(00000380h + (channel - 1) * 32, (80h Or reg_adr))     ' Header 2
  nop
  For cnt_i = 1 To cnt_dat                                  ' data count
    out(00000380h + (channel - 1) * 32, buf[cnt_i])         '
  Next cnt_i
  Sub_End_critical_section
EndSub

'---------------------------------------------------------------
' Function only For internal use!
' send LS-Bus no acknowlege
' channel : number of the LS interface on the LS module
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' value  : outvalue 32 bit
'---------------------------------------------------------------
Sub I_Send_NA32(channel, dev_adr, reg_adr,value) ''<HIDE>
  Dim cnt_i, ftc As Long

  Do
    ftc = IN(00000386h + (channel - 1) * 32)                ' tx FIFO count
  Until (ftc < (28 - 4))
  Sub_begin_critical_section
  out(00000380h + (channel - 1) * 32, (Shift_Left(4 - 1, 4) Or dev_adr))  ' Header 1
  nop
  out(00000380h + (channel - 1) * 32, (80h Or reg_adr))     ' Header 2
  nop
  For cnt_i = 0 To 24 step 8                                    ' data count
    out(00000380h + (channel - 1) * 32, shift_right(value,cnt_i) AND 0FFH)          '
  Next cnt_i
  Sub_End_critical_section
EndSub


'---------------------------------------------------------------
' Function only For internal use!
' send LS-Bus broadcast no acknowlege
' module  : module address
' channel : number of the LS interface on the LS module
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
'---------------------------------------------------------------
Sub I_Send_BC(channel, reg_adr, cnt_dat, buf[]) ''<HIDE>
  Dim cnt_i, ftc As Long

  Do
    ftc = IN(00000386h + (channel - 1) * 32)                ' tx FIFO count
  Until (ftc < (28 - cnt_dat))
  Sub_begin_critical_section
  out(00000380h + (channel - 1) * 32, (Shift_Left(cnt_dat - 1, 4)))  ' Header 1
  nop
  out(00000380h + (channel - 1) * 32, (80h Or reg_adr))     ' Header 2
  nop
  For cnt_i = 1 To cnt_dat
    out(00000380h + (channel - 1) * 32, buf[cnt_i])         ' data count
  Next cnt_i
  Sub_End_critical_section
EndSub


'---------------------------------------------------------------
' Function only For internal use!
' send LS-Bus broadcast no acknowlege
' module  : module address
' channel : number of the LS interface on the LS module
' reg_adr : adress of register (JX/FPGA)
' value   : out byte
'---------------------------------------------------------------
Sub I_Send_BC8(channel, reg_adr, value) ''<HIDE>
  Dim ftc As Long

  Do
    ftc = IN(00000386h + (channel - 1) * 32)                ' tx FIFO count
  Until (ftc < (28 - 1))
  Sub_begin_critical_section
  out(00000380h + (channel - 1) * 32, (Shift_Left(1 - 1, 4)))  ' Header 1
  nop
  out(00000380h + (channel - 1) * 32, (80h Or reg_adr))     ' Header 2
  nop

  out(00000380h + (channel - 1) * 32, value)         ' data count

  Sub_End_critical_section
EndSub
'---------------------------------------------------------------
' Request to read data
' channel : number of the LS interface on the LS module
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
'---------------------------------------------------------------
Sub LS_Read_Req(channel, ls_module, reg_adr, cnt_dat) ''<HIDE>
  Dim ftc As Long

  Do
    ftc = IN(00000386h + (channel - 1) * 32)                ' tx FIFO count
  Until (ftc < 28)
  Sub_begin_critical_section
  out(00000380h + (channel - 1) * 32, (Shift_Left(cnt_dat - 1, 4) Or ls_module))  'header 1
  nop
  out(00000380h + (channel - 1) * 32, reg_adr)              ' Header 2
  nop
  Sub_End_critical_section
EndSub


'---------------------------------------------------------------
' Read response (only DIG_IO request)
' channel : number of the LS interface on the LS module
' return  : state of digital outputs and inputs
'---------------------------------------------------------------
Function LS_Read_Resp_DIO(channel) As Long ''<HIDE>
  Dim ld[4] As Long At DM_Local
  Dim cnt_i As Long

  For cnt_i = 1 To 4                                        ' rx data read
    ld[cnt_i] = IN(00000380h + (channel - 1) * 32)          ' rx data read
  Next cnt_i
  LS_Read_Resp_DIO = ld[1] Or (Shift_Left(ld[2], 8)) Or (Shift_Left(ld[3], 16)) Or (Shift_Left(ld[4], 24))
EndFunction


'---------------------------------------------------------------
' Read response
' channel : number of the LS interface on the LS module
' cnt_dat : count of data (1..16)
' buf[]   : array (min len is cnt_dat)
' return  : error code (0->ok)
'---------------------------------------------------------------
Function LS_Read_Resp(channel, cnt_dat, buf[]) As Long ''<HIDE>
  Dim cnt_i As Long
  For cnt_i = 1 To cnt_dat                                  ' rx data read
    buf[cnt_i] = IN(00000380h + (channel - 1) * 32)         ' rx data read
  Next cnt_i
  LS_Read_Resp = IN(00000380h + (channel - 1) * 32)         ' acknowledge
EndFunction


'******************************************************************************
'''Resets the watchdog timer, sets digital outputs and
'''+reads digital inputs.
'''+return: state of digital outputs and inputs
'''channel: number of the LS interface on the LS module (1..2)
'''+ ls_module: device nr lsbus (FIX 1)
'''value: each bit corresponds to a channel
'''****************************************************************************
Function LS_Dig_IO(channel, value) As Long
  dim invalue as long
  Dim cnt_i As Long

  invalue=0
  For cnt_i = 0 To 24 step 8 
    invalue=invalue OR  shift_left( IN(00000380h + (channel - 1) * 32),cnt_i)          ' rx data read
  Next cnt_i
  LS_Dig_IO = invalue
                                             
  I_Send_BC8(channel, 44h, 1)  ' WD trigger

  I_Send_NA32(channel, 1, 7Ch, value)                         ' channel 1..32
  LS_Read_Req(channel, 1, 7Ch, 4)                           ' request new in data
EndFunction


'******************************************************************************
'''Enables, disables and configures the watchdog.
'''+return: error code (0->ok)
'''channel: number of the LS interface on the LS module (1..2)
'''ls_module: device nr lsbus (1..15)
'''enable:  
'''+           0->disable
'''+           1->enable
'''time: trigger time [ms]
'''****************************************************************************
Function LS_Watchdog_Init(channel, ls_module, enable, time) As Long
  Dim ld[2] As Long 
  Dim ret, t As Long

  'Watchdog disable
  ld[1] = 0ADh
  ld[2] = 0
  ret = I_Send(channel, ls_module, 45h, 2, ld)
  'Watchdog time
  t = time * 40000                                          't = time / 25e-6
  ret = ret Or (I_Send32(channel, ls_module, 48h,t))
  ' Watchdog enable
  ld[1] = 0ADh
  ld[2] = enable And 1
  LS_Watchdog_Init = ret Or (I_Send(channel, ls_module, 45h, 2, ld))
EndFunction


'******************************************************************************
'''Resets the watchdog timer.
'''+If the watchdog is activated, the user program has to call
'''+this Function at least every ....
'''channel: number of the LS interface on the LS module (1..2)
'''****************************************************************************
Sub LS_Watchdog_Reset(channel)
  I_Send_BC8(channel, 44h, 1)
EndSub


'******************************************************************************
'''Initializes a digital I/O module (channel 0-31).
'''+return: error code (0->ok)
'''channel: number of the LS interface on the LS module(1..2)
'''ls_module: device nr LS-bus (1..15)
'''value: each bit corresponds to 8 channel
'''+           0 -> input
'''+           1 -> output
'''+           bit 0: channels 1..8
'''+               1: channels 9..16
'''+               2: channels 17..24
'''+               3: channels 25..32
'''****************************************************************************
Function LS_DigProg(channel, ls_module, value) As Long
  Dim ld[2] As Long At DM_Local
  Dim ret As Long

  ld[1] = (Shift_Left(value, 3) And 8h) OR  (Shift_Left(value, 7)AND 80H) OR  11H' As after reset                                     
  ld[2] = (Shift_Left(value, 2) And 8h) OR  (Shift_Left(value, 6) And 80h) OR 11H
  ret = I_Send(channel, ls_module, 16h, 2, ld)
  ld[1] = (Shift_Left(value, 1) And 8h)  Or (Shift_Left(value, 5) And 80h) OR 11H
  ld[2] = (value And 8h)  Or (Shift_Left(value, 4) And 80h) OR 11H
  LS_DigProg = ret Or (I_Send(channel, ls_module, 20h + 16h, 2, ld))
EndFunction


'******************************************************************************
'''Sets the digital outputs (channel 0 - 31).
'''channel: number of the LS interface on the LS module (1..2)
'''ls_module: device nr LS-bus (1..15)
'''value: each bit corresponds to a channel
'''****************************************************************************
Sub LS_Digout_Long(channel, ls_module, value)
  I_Send_NA32(channel, ls_module, 7Ch,value)                 ' channel 1..32
EndSub


'******************************************************************************
'''Sets the digital outputs (channel 0 - 31).
'''channel: number of the LS interface on the LS module (1..2)
'''ls_module: device nr LS-bus (1..15)
'''value: each bit corresponds to a channel
'''BUS_stat: error code 0=OK 
'''****************************************************************************
Sub LS_Digout_Long_BS(channel, ls_module, value,BUS_Stat)
  BUS_Stat=I_Send32(channel, ls_module, 7Ch, value)                 ' channel 1..32
EndSub

'******************************************************************************
'''Reads the digital inputs (channel 0 - 31).
'''+return: state of digital outputs and inputs
'''channel: number of the LS interface on the LS module (1..2)
'''ls_module: device nr LS-bus (1..15)
'''****************************************************************************
Function LS_Digin_Long(channel, ls_module) As Long
  Dim ret As Long
  ret = I_Receive32(channel, ls_module, 7Ch,LS_Digin_Long)
EndFunction

'******************************************************************************
'''Reads the digital inputs (channel 0 - 31).
'''+return: state of digital outputs and inputs
'''channel: number of the LS interface on the LS module (1..2)
'''ls_module: device nr LS-bus (1..15)
'''BUS_stat: error code 0=OK 
'''****************************************************************************
Function LS_Digin_Long_BS(channel, ls_module,BUS_Stat) As Long
  BUS_Stat = I_Receive32(channel, ls_module, 7Ch,LS_Digin_Long_BS)
EndFunction

'******************************************************************************
'''Reads the digital output status (overcurrent) (channel 0 - 31).
'''+return: each bit corresponds a channel 0 = OK 1 = Error
'''channel: number of the LS interface on the LS module (1..2)
'''ls_module: device nr lsbus (1..15)
'''****************************************************************************
Function LS_Get_Output_Status(channel, ls_module) As Long
  Dim t As Long
  t = I_Receive32(channel, ls_module, 50h, LS_Get_Output_Status)
EndFunction

'******************************************************************************
'''Initializes the LS-Module
'''+return: error code (0->ok)
'''channel: number of the LS interface on the LS module (1..2)
'''ls_module: device nr LS-bus (1..15)
'''****************************************************************************
Function LS_DIO_Init(channel, ls_module) As Long
  Dim ld[4] As Long At DM_Local
  Dim ret As Long
  Dim addr As Long

  out(0000038Eh + (channel - 1) * 32, 1)                    ' ' autoreset rx ON
  ld[1] = 3
  ret = I_Send(channel, ls_module, 40h, 1, ld)              ' Reset JX 1, 2
  ld[1] = 1
  ret = ret Or (I_Send(channel, ls_module, 5Ch, 1, ld))     ' timeout reset
  ld[1] = 4
  ret = ret Or (I_Send(channel, ls_module, 4Ch, 1, ld))     ' Set default direction time
  ld[1] = 0
  ld[2] = 0
  ld[3] = 0
  ld[4] = 0
  LS_DIO_Init = ret Or (I_Send(channel, ls_module, 50h, 4, ld))  ' overcurrent reset
  ld[1] = 30h
  LS_DIO_Init = ret Or (I_Send(channel, ls_module, 43h, 1, ld))  ' overtemperature reset
EndFunction

'<ENDREGION>

'<REGION> SSI

'******************************************************************************
'''Reads the SSI encoder value 32 Bit.
'''counter: number of the counter (1..2)
'''****************************************************************************
FUNCTION SSI_Read(counter) AS long
  SSI_Read = IN(000003C6h + (counter - 1) * 8)              'read 32 Bit-value
ENDFUNCTION


'******************************************************************************
'''Sets the number of databits for the SSI Interface.
'''counter: number of the counter (1..2)
'''value: number of bits
'''****************************************************************************
SUB SSI_Set_Bits(counter, value)
  out((000003C4h + (counter - 1) * 8), value)
ENDSUB


'******************************************************************************
'''Sets frequency of the SSI clock.
'''counter: number of the counter (1..2)
'''value: frequency = 25MHZ / value
'''****************************************************************************
SUB SSI_Set_Clock(counter, value)
  out((000003C2h + (counter - 1) * 8), value)
ENDSUB


'******************************************************************************
'''Starts the SSI interface.
'''pattern: Bit pattern each bit corresponds to one counter
'''****************************************************************************
SUB SSI_Start(pattern)
  out(000003C0h, (pattern) AND 0FH)
ENDSUB


'******************************************************************************
'''Sets the SSI mode.
'''value: bit pattern each bit corresponds to one counter
'''+         0 = single start mode
'''+         1 = continuous start mode
'''****************************************************************************
sub SSI_Mode(value)
  out(000003C8h, (value) AND 0FH)
endsub


'******************************************************************************
'''Reads the SSI status.
'''+return value: 
'''+               0 = SSI value compleated
'''+               1 = SSI transfer running
'''counter:        number of the SSI counter(1..4)
'''****************************************************************************
FUNCTION SSI_Status(counter) AS long
  dim value2 as long
  value2 = IN(000003C0h)
  ssi_status = shift_right(value2, (counter - 1)) AND 01H
ENDFUNCTION

'<ENDREGION>

'<REGION> RS232/RS485

'******************************************************************************
'''Sets a register of the serial controller.
'''register_no: register on the serial controller (0..31)
'''value: value for the selected register
'''****************************************************************************
sub Set_RS(register_no, value)

  dim h as long
  SUB_BEGIN_CRITICAL_SECTION
  out(00000410h, value)                                     'write data
  nop
  nop
  nop
  nop
  out(00000408h, register_no)                               'write write adresse adresse

  nop
  nop
  nop
  nop

  do

    nop
    h = IN(00000410h)                                       'wait while busy
  until ((h and 0100h) = 0)
  SUB_END_CRITICAL_SECTION
endsub

'******************************************************************************
'''Reads the value of a register of the serial controller.
'''register_no: register on the serial controller (0..31)
'''****************************************************************************
FUNCTION Get_RS(register_no) AS Long

  dim busy as long

  SUB_BEGIN_CRITICAL_SECTION


  out(00000400h, register_no)                               'write read adress
  '
  nop
  nop
  nop
  nop


  do
    nop
    busy = IN(00000410h)                                    'wait while busy
  until (busy and 0100h = 0)

  Get_RS = busy

  SUB_END_CRITICAL_SECTION

ENDFUNCTION


'******************************************************************************
'''Initializes  a serial interface.
'''channel: number of the serial interface (1 or 2)
'''Baud_rate: baudrate for the serial comunication
'''+ 2304000
'''+ 1152000
'''+  460800
'''+  230400
'''+  115200
'''+   57600
'''+   38400
'''+   19200
'''+    9600
'''+    4800
'''+    2400
'''+    1200
'''+     600
'''+     300
'''parity:     
'''+             0 = no parity
'''+             1 = even
'''+             2 = odd
'''word_length: Number of databits for the serial comunication(5..8)
'''stop_bits:   
'''+             0 = 1 Stopbit
'''+             1 = 1, 5 Stopbits by using 5 Databits
'''+             1 = 2 Stopbits bei 6, 7 by using 8 Databits
'''handshake:   
'''+             0 = RS-232 no handshake
'''+             1 = RS-232 Hardware handshake (RTS/CTS)
'''+             2 = RS-232 Software handshake (Xon/Xoff)
'''+             3 = RS-485 no handshake
'''****************************************************************************
sub RS_Init(channel, Baud_rate, parity, word_length, stop_bits, handshake)
  dim offset as Long                                        ' offset for the selected serial interface
  dim divisor as Long                                       ' value by which the external clock has to be divided to get the selected baudrate
  dim DLL_value as Long                                     ' value for the DLL register
  dim DLH_value as Long                                     ' value for the DLH register
  dim LCR_value as Long                                     ' value for the LCR register
  dim bmode as long
  dim mode as long

  offset = (channel - 1) * 8

  bmode = shift_left(1, channel - 1)
  mode = IN(00000430h) AND not (bmode)                      'rs232 or rs485?


  if (Handshake = 3) then                                   'rs485
    out(00000430h, mode)
  else                                                      'rs232

    out(00000430h, mode or bmode)
  endif

  divisor = (36864000) / (Baud_rate * 16)                   ' calculates the the divider for the external clock
  DLL_value = divisor and 0ffh                              ' value for the DLL register
  DLH_value = shift_right((divisor and 0ff00h), 8)          ' value for the DLH register

  LCR_value = word_length - 5
  LCR_value = LCR_value or shift_left(stop_bits, 2)
  if (parity = 1) then LCR_value = LCR_value or 011000b
  if (parity = 2) then LCR_value = LCR_value or 001000b     'value for the LCR register

  set_rs(offset + 3, 080h)                                  ' LCR-bit7=1    Divisor latch enable
  set_rs(offset + 0, DLL_value)                             ' DLL-reg               setting baudrate
  set_rs(offset + 1, DLH_value)                             ' DLH-reg               setting baudrate
  set_rs(offset + 3, (0bfh))                                ' LCR-reg               Enhanced feature reg enable
  set_rs(offset + 4, 011h)                                  ' setting character for softwarehandshake Xon1
  set_rs(offset + 5, 012h)                                  ' setting character for softwarehandshake Xon2
  set_rs(offset + 6, 013h)                                  ' setting character for softwarehandshake Xoff1
  set_rs(offset + 7, 014h)                                  ' setting character for softwarehandshake Xoff2
  if (handshake = 0) then
    set_rs(offset + 2, 010h)                                ' EFR-reg               no handshake(RS232) + enhanced functions enabeld
  endif
  if (handshake = 1) then
    set_rs(offset + 2, 0d0h)                                ' EFR-reg               hardwarehandshake(RS232) + enhanced functions enabeld
  endif
  if (handshake = 2) then
    set_rs(offset + 2, 01ah)                                ' EFR-reg               softwarehandshake(RS232) (Xon1/Xoff1) + enhanced functions enabeld
  endif
  if (handshake = 3) then
    set_rs(offset + 2, 010h)                                ' EFR-reg               no handshake (RS485) + enhanced functions enabeld
  endif
  set_rs(offset + 3, LCR_value)                             ' LCR-reg               Divisor latch disable; 8 Databits
  set_rs(offset + 4, 040h)                                  ' MCR reg               enable access to TCR and TLR register
  set_rs(offset + 6, 087h)                                  ' TCR reg               FIFO trigger level
  set_rs(offset + 4, 04h)                                   ' MCR reg               FIFOrdy reg enable; is necessary to get status information of the FIFO
  set_rs(offset + 2, 00fh)                                  ' FCR-reg               FIFOs enable, FIFOs clear, DMA Mode1
endsub


'******************************************************************************
'''Resets the serial interface module.
'''****************************************************************************
sub RS_Reset()


  'POKE_FAST_BUS((32000021h OR shift_left(module, 16)), 0) 'reset 200 ns !!

  out(0000041Ch, 1)                                         'reset
  sleep(2)
  out(0000041Ch, 0)                                         'reset
  sleep(2)

  out(00000430h, 0)                                         'ch1 and ch2 rs485

  'POKE_FAST_BUS((32000022h OR shift_left(module, 16)), 1) 'RS 485 CH1 485
  'POKE_FAST_BUS((32000023h OR shift_left(module, 16)), 1) 'RS 485 CH2 485
  'POKE_FAST_BUS((32000024h OR shift_left(module, 16)), 1) 'RS 485 CH3 485
  'POKE_FAST_BUS((32000025h OR shift_left(module, 16)), 1) 'RS 485 CH4 485

  out(00000420h, 0)                                         'RS 485 CH1 reseive
  out(00000428h, 0)                                         'RS 485 CH2 reseive
  'POKE_FAST_BUS((32000026h OR shift_left(module, 16)), 0)
  'POKE_FAST_BUS((32000027h OR shift_left(module, 16)), 0)
  'POKE_FAST_BUS((32000028h OR shift_left(module, 16)), 0) 'RS 485 CH3 reseive
  'POKE_FAST_BUS((32000029h OR shift_left(module, 16)), 0) 'RS 485 CH4 reseive

endsub


'******************************************************************************
'''Writes a byte to the transmit FIFO, if the FIFO is not full.
'''+return value:
'''+write_fifo: 
'''+            0 = byte is written
'''+            1 = FIFO full
'''channel: number of the serial interface
'''value: value which should be written to the FIFO
'''****************************************************************************
function Write_FIFO(channel, value) as Long
  dim offset as Long                                        ' offset for the selected serial interface
  dim bit as Long
  dim fifo_free as Long                                     ' FIFO status

  bit = shift_left(1, channel - 1)

  offset = (channel - 1) * 8
  fifo_free = get_rs(7 + offset) and bit
  if (fifo_free <> 0) then                                  ' If the FIFO is not full then the byte is written
    set_rs(offset, value)                                   ' Writeing byte to transmit FIFO
    write_fifo = 0                                          ' return value: byte is written successful to the transmit FIFO
  else
    write_fifo = 1                                          ' return value: Fifo full; byte is not written
  endif
endfunction

'******************************************************************************
'''Checks if write fifo is full.
'''+return value:
'''+             0->one or more byte in write fifo is free
'''+             1->FIFO full
'''channel: number of the serial interface
'''****************************************************************************
function Write_FIFO_Full(channel) as Long
  dim offset as Long                                        ' offset for the selected serial interface
  dim bit as Long
  dim fifo_free as Long                                     ' FIFO status

  bit = shift_left(1, channel - 1)

  offset = (channel - 1) * 8
  fifo_free = get_rs(7 + offset) and bit
  if (fifo_free = 0) then                                 
    write_fifo_full = 0                                          ' return value: byte is written successful to the transmit FIFO
  else
    write_fifo_full = 1                                          ' return value: Fifo full; byte is not written
  endif
endfunction


'******************************************************************************
'''Checks if there is any more data to transmit.
'''+return value:
'''+check_shift_reg : 
'''+                  0 = Shift register and transmit hold are empty
'''+                  1 = Shift register and transmit hold are not empty
'''channel:  number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
'''****************************************************************************
function Check_Shift_Reg(channel) as Long
  dim offset as Long                                        ' offset for the selected serial interface
  dim ret as Long                                           ' return value

  offset = (channel - 1) * 8

  ret = get_rs(offset + 5) and 64                           ' reading the status byte
  if (ret = 64) then
    check_shift_reg = 0
  else
    check_shift_reg = 1
  endif
endfunction


'******************************************************************************
'''Reads byte from the receive FIFO's return value:
'''+read_fifo: 
'''+        0 - 255 = value of the received byte
'''+       -1 = no bytes in the receive FIFO
'''channel: number of the serial interface (one ADwin-PRO module contains 2 or 4 interfaces)
'''****************************************************************************
function Read_FIFO(channel) as Long
  dim offset as Long                                        ' offset for the selected serial interface
  dim fifo_status as Long                                   ' FIFO status
  offset = (channel - 1) * 8

  fifo_status = get_rs(offset + 5) and 1
  if (fifo_status <> 0) then                                ' read byte, if there is a byte in the receive FIFO
    read_fifo = get_rs(offset)                              ' read byte from receive FIFO (return value = value of the received byte)
  else
    read_fifo = -1                                          ' no new byte in the receive FIFO (return value = -1)
  endif
endfunction


'******************************************************************************
'''Selects whether the interface is sending data or is listening on the bus.
'''+Only for RS485.
'''channel: number of the serial interface
'''value:        
'''+               0 = Listening
'''+               1 = Sending Data
'''+               2 = Sending Data + Listening
'''+               3=  mute (default)
'''****************************************************************************
sub RS485_Send(channel, value)
  out(00000418h + 8 * channel, value + 1)                   'write read adress
endsub

'<ENDREGION>

'<REGION> RTC

'******************************************************************************
'''Reads out the current date and time from the RTC at once.
'''+parameters are preferably Longs.
'''year:   Last two digits of the year 0...99 (Long)
'''month:  1...12 (Long)
'''day:    1...31 (Long)
'''hour:   0...23 (Long)
'''minute: 0...59 (Long)
'''second: 0...59 (Long)
'''****************************************************************************
SUB RTC_Get(year, month, day, hour, minute, second)

  dim i, p as long
 
  sub_begin_critical_section
  i = IN(00000250h)
  second = (shift_right(i, 4) AND 0FH) * 10 + (i AND 0FH)
  sub_end_critical_section
  
  p = IN(00000252h)
 
  minute = (shift_right(i, 12) AND 0FH) * 10 + (shift_right(i, 8) AND 0FH)
  hour = (shift_right(i, 20) AND 0FH) * 10 + (shift_right(i, 16) AND 0FH)


  year = (shift_right(p, 4) AND 0FH) * 10 + (p AND 0FH)
  month = (shift_right(p, 12) AND 0FH) * 10 + (shift_right(p, 8) AND 0FH)
  day = (shift_right(p, 20) AND 0FH) * 10 + (shift_right(p, 16) AND 0FH)

endsub

'<ENDREGION>

'<REGION> CAN

#If MAKE_LIB = OFF Then
'******************************************************************************
'''Enables a message object for receiving messages.
'''+Disables all interrups of the message object.
'''channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
'''msg_no:  Number of the message object
'''identifier: incomming frames are accepted by this message object, if the identifier matches the frame identifier
'''extended: Determines whether the identifier is 11 or 29 Bit
'''+             0 = 11 Bit identifier
'''+             1 = 29 Bit identifier
'''****************************************************************************
Sub En_Receive(channel, msg_no, identifier, extended)
  Set_CAN_Reg(channel, (msg_no) * 16, 149)                    'enable message object
  If (extended = 0) Then
    Set_CAN_Reg(channel, (msg_no) * 16 + 6, 128)              'read; DLC = 8 ; 11 Bit identifier
    Set_CAN_Reg(channel, (msg_no) * 16 + 2, (Shift_Right(identifier, 3) And 255))  'Set identifier
    Set_CAN_Reg(channel, (msg_no) * 16 + 3, (Shift_Left(identifier, 5) And 255))
  Else
    Set_CAN_Reg(channel, (msg_no) * 16 + 6, 132)              'read; DLC = 8 ; 29 Bit identifier
    Set_CAN_Reg(channel, (msg_no) * 16 + 2, (Shift_Right(identifier, 21) And 255))  'Set identifier
    Set_CAN_Reg(channel, (msg_no) * 16 + 3, (Shift_Right(identifier, 13) And 255))
    Set_CAN_Reg(channel, (msg_no) * 16 + 4, (Shift_Right(identifier, 5) And 255))
    Set_CAN_Reg(channel, (msg_no) * 16 + 5, (Shift_Left(identifier, 3) And 255))
  EndIf
EndSub


'******************************************************************************
'''Enables a message object for transmitting messages.
'''+Disables all interrups of the message object.
'''channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
'''msg_no:  Number of the message object
'''identifier: identifier for the frames which will be transmitted
'''extended: Determines whether the identifier is 11 or 29 Bit
'''+             0 = 11 Bit identifier
'''+             1 = 29 Bit identifier
'''****************************************************************************
Sub En_Transmit(channel, msg_no, identifier, extended)
  Dim bit As Long
  Set_CAN_Reg(channel, (msg_no) * 16, 149)                    'enable message object
  If ((extended And 2) = 0) Then
    bit = 0
  Else
    bit = 8
  EndIf
  If ((extended And 1) = 0) Then
    Set_CAN_Reg(channel, (msg_no) * 16 + 6, (136 - bit))      'write; DLC = 8 ; 11 bit identifier
    Set_CAN_Reg(channel, (msg_no) * 16 + 2, (Shift_Right(identifier, 3) And 255))  'Set identifier
    Set_CAN_Reg(channel, (msg_no) * 16 + 3, (Shift_Left(identifier, 5) And 255))
  Else
    Set_CAN_Reg(channel, (msg_no) * 16 + 6, (140 - bit))      'write; DLC = 8 ; 29 bit identifier
    Set_CAN_Reg(channel, (msg_no) * 16 + 2, (Shift_Right(identifier, 21) And 255))  'Set identifier
    Set_CAN_Reg(channel, (msg_no) * 16 + 3, (Shift_Right(identifier, 13) And 255))
    Set_CAN_Reg(channel, (msg_no) * 16 + 4, (Shift_Right(identifier, 5) And 255))
    Set_CAN_Reg(channel, (msg_no) * 16 + 5, (Shift_Left(identifier, 3) And 255))
  EndIf
EndSub


'******************************************************************************
'''Initializes the CAN-controller.
'''+All message objects will be disabled.
'''+Bitrate: 1MBit/s
'''+Acceptance filter: Must match
'''channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
'''****************************************************************************
Sub Init_CAN(channel)
  Dim counter As Long

  'reset
  out(00000414h, shift_left(1, channel - 1))                'write data
  Sleep(1000)                                               ' Reset pin must be low for at least 1 ms
  out(00000414h, 0)                                         'write data



  Set_CAN_Reg(channel, 0, 65)                               'Access to the registers of the controller only for CPU
  Set_CAN_Reg(channel, 2, 65)                               'CPU interface register
  
  
  for counter=6 to 15
    Set_CAN_Reg(channel, counter, 0FFh)                           'Setting all masks to "must match"
  next  
  'Set_CAN_Reg(channel, 06h, 0FFh)                           'Setting all masks to "must match"
  'Set_CAN_Reg(channel, 07h, 0FFh)
  'Set_CAN_Reg(channel, 08h, 0FFh)
  'Set_CAN_Reg(channel, 09h, 0FFh)
  'Set_CAN_Reg(channel, 0Ah, 0FFh)
  'Set_CAN_Reg(channel, 0Bh, 0FFh)
  'Set_CAN_Reg(channel, 0Ch, 0FFh)
  'Set_CAN_Reg(channel, 0Dh, 0FFh)
  'Set_CAN_Reg(channel, 0Eh, 0FFh)
  'Set_CAN_Reg(channel, 0Fh, 0FFh)
  
  
  
  Set_CAN_Reg(channel, 01Fh, 0)                             ' Clock Out Register
  Set_CAN_Reg(channel, 02Fh, 0)                             ' Bus configuration register
  Set_CAN_Reg(channel, 03Fh, 0)                             ' Bit Timing register 0
  Set_CAN_Reg(channel, 04Fh, 032h)                          ' Bit Timing register 1

  For counter = 1 To 15                                     'Disable all message objects
    Set_CAN_Reg(channel, counter * 16, 85)
    Set_CAN_Reg(channel, counter * 16 + 1, 85)
  Next counter
  Set_CAN_Reg(channel, 0, 0)                                'Access to the registers of the controller only for Application
EndSub


'---------------------------------------------------------------
' Aid sub for Read_Msg_Con and Read_Msg.
'---------------------------------------------------------------
Sub read_controller_registers(channel, msg_no, id0, id1, id2, id3, id_length)''<HIDE>
  Dim counter As Long
  Dim buffer As Long

  buffer = (Get_CAN_Reg(channel, (msg_no) * 16 + 6))
  CAN_msg[9] = Shift_Right((buffer And 0F0h), 4)            ' Number of databytes
  id_length = buffer And 4
  id0 = Get_CAN_Reg(channel, (msg_no) * 16 + 2)               ' identifier registers
  id1 = Get_CAN_Reg(channel, (msg_no) * 16 + 3)
  If (id_length = 4) Then
    id2 = Get_CAN_Reg(channel, (msg_no) * 16 + 4)
    id3 = Get_CAN_Reg(channel, (msg_no) * 16 + 5)
  EndIf
  For counter = 1 To CAN_msg[9]                             ' reading databytes
    CAN_msg[counter] = Get_CAN_Reg(channel, ((msg_no) * 16) + counter + 6)
  Next counter
EndSub


'******************************************************************************
'''Checks if there is a new frame in the selected
'''+message object. if there is a new frame all databytes are read
'''+and then written to the array "CAN_msg".
'''+The number of databytes is written to the element 9 of the array "CAN_msg".
'''+The return value of the function is the identifier of the frame.
'''+If there is no new frame in the message box the return value is -1.
'''channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
'''msg_no: number of the message object
'''****************************************************************************
Function Read_Msg(channel, msg_no) As Long
  Dim new As Long                                           ' new message in the message object
  Dim id0, id1, id2, id3 As Long                            ' identifier Byte 0 and 1
  Dim id_length As Long                                     ' buffer to distinguish 11 and 29 bit identifier

  new = Get_CAN_Reg(channel, (msg_no) * 16 + 1) And 3         ' Check, if a new frame in arrived
  If (new = 2) Then                                         ' New frame is arrived
    read_controller_registers(channel, msg_no, id0, id1, id2, id3, id_length)
    Set_CAN_Reg(channel, (msg_no) * 16, 0FDh)                 ' reset interrupt
    Set_CAN_Reg(channel, (msg_no) * 16 + 1, 85)               ' reset the new data flag
    If (id_length = 0) Then
      Read_Msg = (Shift_Right(id1, 5)) Or (Shift_Left(id0, 3))  ' return value = 11 bit identifier
    Else
      Read_Msg = (Shift_Right(id3, 3)) Or (Shift_Left(id2, 5)) Or (Shift_Left(id1, 13)) Or (Shift_Left(id0, 21))  ' return value = 29 bit identifier
    EndIf
  Else
    Read_Msg = -1                                           ' return value = 0
  EndIf
EndFunction


'******************************************************************************
'''Checks, if there is a new frame in the selected
'''+message object. If there is a new frame all databytes are read
'''+and then written to the array "CAN_msg".
'''+The number of databytes is written to the element 9 of the array "CAN_msg".
'''+The return value of the function is the identifier of the frame.
'''+If there is no new frame in the message box the return value is -1.
'''+Checks the consistens of the data and if they ars not consistent
'''+the datas will be reread.
'''channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
'''msg_no: number of the message object
'''*****************************************************************************
Function Read_Msg_Con(channel, msg_no) As Long
  Dim new As Long                                           ' new message in the message object
  Dim id_length As Long                                     ' buffer to distinguish 11 and 29 bit identifier
  Dim id0, id1, id2, id3 As Long                            ' identifier Byte 0 and 1

  new = Get_CAN_Reg(channel, (msg_no) * 16 + 1) And 3         ' Check, if a new frame in arrived
  If (new = 2) Then                                         ' New frame is arrived
    
    If (msg_no = 15) then
      read_controller_registers(channel, msg_no, id0, id1, id2, id3, id_length)
      Set_CAN_Reg(channel, (msg_no) * 16, 0FDh)               ' reset interrupt
      Set_CAN_Reg(channel, (msg_no) * 16 + 1, 85)             ' reset the new data flag
      new = Get_CAN_Reg(channel, (msg_no) * 16 + 1) And 3     ' Check, if a new frame in arrived
      If (new = 2) Then                                     ' New frame is arrived
        read_controller_registers(channel, msg_no, id0, id1, id2, id3, id_length)
        Set_CAN_Reg(channel, (msg_no) * 16, 0FDh)             ' reset interrupt
        Set_CAN_Reg(channel, (msg_no) * 16 + 1, 85)           ' reset the new data flag
      endif
    else
      Set_CAN_Reg(channel, (msg_no) * 16 + 1, 85)             ' reset the new data flag
      read_controller_registers(channel, msg_no, id0, id1, id2, id3, id_length)
      new = Get_CAN_Reg(channel, (msg_no) * 16 + 1) And 3     ' Check, if a new frame in arrived
      If (new = 2) Then                                     ' New frame is arrived
        read_controller_registers(channel, msg_no, id0, id1, id2, id3, id_length)
        Set_CAN_Reg(channel, (msg_no) * 16 + 1, 85)           ' reset the new data flag
      endif
      Set_CAN_Reg(channel, (msg_no) * 16, 0FDh)               ' reset interrupt
      
    endif
    
      
    If (id_length = 0) Then
      Read_Msg_Con = (Shift_Right(id1, 5)) Or (Shift_Left(id0, 3))  ' return value = 11 bit identifier
    Else
      Read_Msg_Con = (Shift_Right(id3, 3)) Or (Shift_Left(id2, 5)) Or (Shift_Left(id1, 13)) Or (Shift_Left(id0, 21))  ' return value = 29 bit identifier
    EndIf
  Else
    Read_Msg_Con = -1                                       ' return value = 0
  EndIf
EndFunction


'******************************************************************************
'''Transmits a frame.
'''+The databytes and the number of databytes have to be written in the
'''+array "CAN_msg" before this Subroutine is activated.
'''+After this subroutine the frame is transmitted as soon as the
'''+CAN-bus allows it.
'''channel: number of the CAN interface on the CAN module
'''msg_no: number of the message object
'''****************************************************************************
Sub Transmit(channel, msg_no)
  Dim buffer As Long
  Dim counter As Long

  For counter = 1 To CAN_msg[9]
    Set_CAN_Reg(channel, ((msg_no) * 10h) + counter + 6, CAN_msg[counter])  'copy datas
  Next counter

  ' Anzahl der Datenbytes bergeben
  buffer = Get_CAN_Reg(channel, ((msg_no) * 10h) + 6) AND 0FH        'read register
  ' buffer = buffer And 0Fh                                   'change DLC Bits
  buffer = buffer Or Shift_Left(CAN_msg[9], 4)
  Set_CAN_Reg(channel, (msg_no) * 16 + 6, buffer)             'write register
  Set_CAN_Reg(channel, (msg_no) * 16 + 1, 102)                ' Control register (setting bit to transmit data)
EndSub


'******************************************************************************
'''Checks if a Messagebox is ready to send. (The last Message is already sent).
'''+return: 
'''+       0 = ready to send
'''+       1 = not ready to send
'''channel: number of the CAN interface on the CAN module
'''msg_no: number of the message object
'''****************************************************************************
Function Transmit_Status(channel, msg_no) as long
  Transmit_Status = shift_right(Get_CAN_Reg(channel, ((msg_no) * 10h) + 1), 5) and 1  ' Control 1register
EndFunction


'******************************************************************************
'''Enables the interrupt of a message object.
'''channel: number of the CAN interface on the CAN module
'''msg_no: number of the message object
'''****************************************************************************
Sub En_CAN_Interrupt(channel, msg_no)
  Set_CAN_Reg(channel, (msg_no) * 16, 0EBh)                   'Enable interrupt of the message object.
  Set_CAN_Reg(channel, 0, 02h)                              'Enable global interrupt.
EndSub


'******************************************************************************
'''Sets a register of the CAN-controller.
'''channel: number of the CAN interface on the CAN module
'''regno: register which should be set
'''value: value which should be written to the register.
'''****************************************************************************
Sub Set_CAN_Reg(channel, regno, value)
  dim h as long
 
  SUB_BEGIN_CRITICAL_SECTION
  out(00000410h, value)                                     'write data
  nop 
  out(0000040Ah + (channel) * 2, regno)                     'write write adresse adresse
  nops(4)

  do
    nop
    h = IN(00000410h)                                  'wait while busy
  until ((h and 0100h) = 0)
  SUB_END_CRITICAL_SECTION

EndSub


'******************************************************************************
'''Reads a register of the CAN-controller.
'''+return value : value of the register
'''channel: number of the CAN interface on the CAN module
'''+          (also necessary if the module provides only one channel)
'''regno: register to read
'''****************************************************************************
Function Get_CAN_Reg(channel, regno) As Long

  SUB_BEGIN_CRITICAL_SECTION
  out(00000402h + (channel) * 2, (regno))                   'write read adress
  nops(4)
  do
    Get_CAN_Reg = IN(00000410h)                               'wait while busy
  until (Get_CAN_Reg and 0100h = 0)
  SUB_END_CRITICAL_SECTION
  
EndFunction


'******************************************************************************
'''Sets the baudrate of the CAN-Bus.
'''+return value 
'''+               0 = baudrate is set
'''+               1 = the selected baudrate is not set
'''channel: number of the CAN interface on the CAN module
'''+(also necessary if the module provides only one channel)
'''baud: CAN-Bus baudrate
'''****************************************************************************
Function Set_CAN_Baudrate(channel, baud) As Long
  Dim scale As Long
  Dim fbuffer As long
  Dim lbuffer As Long
  Dim back As Long
  Dim tseg1 As Long
  Dim tseg2 As Long
  Dim brp As Long
  Dim btr0 As Long
  Dim btr1 As Long

  dim hscale as long
  dim hbaud as long

  fbuffer = 8000000 / baud

  scale = fbuffer                                           'total scale to achive the baudrate
  hbaud = (fbuffer) * baud

  if (absi(hbaud - 8000000) < 1100) then
    Set_CAN_Baudrate = 0                                    '                                '1 if baudrate not possible
  else
    Set_CAN_Baudrate = 1
  endif


  If (Set_CAN_Baudrate = 0) Then                            'If baudrate possible then find settings

    brp = (scale - 1) / 25                                  'Prescaler

    Do                                                      'find the right brp
      fbuffer = scale / (brp + 1) - 3
      hscale = (fbuffer + 3) * (brp + 1)                    'Inc prescaler Until tseg1 + tseg 2 is an Long
      back = scale - hscale
      Inc(brp)
    Until ((back = 0) Or (fbuffer < 5))
    Dec(brp)
    If (back <> 0) Then Set_CAN_Baudrate = 1

  EndIf

  If (Set_CAN_Baudrate = 0) Then                            'If there is a correct prescaler
    tseg2 = fbuffer * 4 / 10
    tseg1 = fbuffer - tseg2
    If (tseg2 > 7) Then
      Do
        Dec(tseg2)
        Inc(tseg1)
      Until (tseg2 = 7)
    EndIf
    btr0 = brp                                              'Synchronization jump width = 1 (bits = 0)
    btr1 = tseg1 + Shift_Left(tseg2, 4)                     'one sampling each Bit
    Set_CAN_Reg(channel, 0, 65)                             'enable access to btr regisers
    Set_CAN_Reg(channel, 3Fh, btr0)                         'set btr0 regisers
    Set_CAN_Reg(channel, 4Fh, btr1)                         'set btr1 regisers
    Set_CAN_Reg(channel, 0, 0)                              'disable access to btr regisers
  EndIf
EndFunction

#else
'******************************************************************************
'''Enables a message object for receiving messages.
'''Disables all interrups of the message object.
'''channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
'''msg_no:  Number of the message object
'''identifier: incomming frames are accepted by this message object, if the identifier matches the frame identifier
'''extended: Determines whether the identifier is 11 or 29 Bit
'''+             0 = 11 Bit identifier
'''+             1 = 29 Bit identifier
'''****************************************************************************
Sub En_Receive(channel, msg_no, identifier, extended) ''<HIDE>
  Set_CAN_Reg(channel, (msg_no) * 16, 149)                    'enable message object
  If (extended = 0) Then
    Set_CAN_Reg(channel, (msg_no) * 16 + 6, 128)              'read; DLC = 8 ; 11 Bit identifier
    Set_CAN_Reg(channel, (msg_no) * 16 + 2, (Shift_Right(identifier, 3) And 255))  'Set identifier
    Set_CAN_Reg(channel, (msg_no) * 16 + 3, (Shift_Left(identifier, 5) And 255))
  Else
    Set_CAN_Reg(channel, (msg_no) * 16 + 6, 132)              'read; DLC = 8 ; 29 Bit identifier
    Set_CAN_Reg(channel, (msg_no) * 16 + 2, (Shift_Right(identifier, 21) And 255))  'Set identifier
    Set_CAN_Reg(channel, (msg_no) * 16 + 3, (Shift_Right(identifier, 13) And 255))
    Set_CAN_Reg(channel, (msg_no) * 16 + 4, (Shift_Right(identifier, 5) And 255))
    Set_CAN_Reg(channel, (msg_no) * 16 + 5, (Shift_Left(identifier, 3) And 255))
  EndIf
EndSub


'******************************************************************************
'''Enables a message object for transmitting messages.
'''Disables all interrups of the message object.
'''channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
'''msg_no:  Number of the message object
'''identifier: identifier for the frames which will be transmitted
'''extended: Determines whether the identifier is 11 or 29 Bit
'''+             0 = 11 Bit identifier
'''+             1 = 29 Bit identifier
'''****************************************************************************
Sub En_Transmit(channel, msg_no, identifier, extended) ''<HIDE>
  Dim bit As Long
  Set_CAN_Reg(channel, (msg_no) * 16, 149)                    'enable message object
  If ((extended And 2) = 0) Then
    bit = 0
  Else
    bit = 8
  EndIf
  If ((extended And 1) = 0) Then
    Set_CAN_Reg(channel, (msg_no) * 16 + 6, (136 - bit))      'write; DLC = 8 ; 11 bit identifier
    Set_CAN_Reg(channel, (msg_no) * 16 + 2, (Shift_Right(identifier, 3) And 255))  'Set identifier
    Set_CAN_Reg(channel, (msg_no) * 16 + 3, (Shift_Left(identifier, 5) And 255))
  Else
    Set_CAN_Reg(channel, (msg_no) * 16 + 6, (140 - bit))      'write; DLC = 8 ; 29 bit identifier
    Set_CAN_Reg(channel, (msg_no) * 16 + 2, (Shift_Right(identifier, 21) And 255))  'Set identifier
    Set_CAN_Reg(channel, (msg_no) * 16 + 3, (Shift_Right(identifier, 13) And 255))
    Set_CAN_Reg(channel, (msg_no) * 16 + 4, (Shift_Right(identifier, 5) And 255))
    Set_CAN_Reg(channel, (msg_no) * 16 + 5, (Shift_Left(identifier, 3) And 255))
  EndIf
EndSub


'******************************************************************************
'''Initializes the CAN-controller.
'''+All message objects will be disabled.
'''+Bitrate: 1MBit/s
'''+Acceptance filter : Must match
'''channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
'''****************************************************************************
Sub Init_CAN(channel) ''<HIDE>
  Dim counter As Long

  'reset
  out(00000414h, shift_left(1, channel - 1))                'write data
  Sleep(1000)                                               ' Reset pin must be low for at least 1 ms
  out(00000414h, 0)                                         'write data



  Set_CAN_Reg(channel, 0, 65)                               'Access to the registers of the controller only for CPU
  Set_CAN_Reg(channel, 2, 65)                               'CPU interface register
  
  
  for counter=6 to 15
    Set_CAN_Reg(channel, counter, 0FFh)        
  next  
    
  'Set_CAN_Reg(channel, 06h, 0FFh)                           'Setting all masks to "must match"
  'Set_CAN_Reg(channel, 07h, 0FFh)
  'Set_CAN_Reg(channel, 08h, 0FFh)
  'Set_CAN_Reg(channel, 09h, 0FFh)
  'Set_CAN_Reg(channel, 0Ah, 0FFh)
  'Set_CAN_Reg(channel, 0Bh, 0FFh)
  'Set_CAN_Reg(channel, 0Ch, 0FFh)
  'Set_CAN_Reg(channel, 0Dh, 0FFh)
  'Set_CAN_Reg(channel, 0Eh, 0FFh)
  'Set_CAN_Reg(channel, 0Fh, 0FFh)
  
  
  
  Set_CAN_Reg(channel, 01Fh, 0)                             ' Clock Out Register
  Set_CAN_Reg(channel, 02Fh, 0)                             ' Bus configuration register
  Set_CAN_Reg(channel, 03Fh, 0)                             ' Bit Timing register 0
  Set_CAN_Reg(channel, 04Fh, 032h)                          ' Bit Timing register 1

  For counter = 1 To 15                                     'Disable all message objects
    Set_CAN_Reg(channel, counter * 16, 85)
    Set_CAN_Reg(channel, counter * 16 + 1, 85)
  Next counter
  Set_CAN_Reg(channel, 0, 0)                                'Access to the registers of the controller only for Application
EndSub


'---------------------------------------------------------------
' Aid sub for Read_Msg_Con and Read_Msg.
'---------------------------------------------------------------
Sub read_controller_registers(channel, msg_no, id0, id1, id2, id3, id_length, CAN_msg[])''<HIDE>
  Dim counter As Long
  Dim buffer As Long

  buffer = (Get_CAN_Reg(channel, (msg_no) * 16 + 6))
  CAN_msg[9] = Shift_Right((buffer And 0F0h), 4)            ' Number of databytes
  id_length = buffer And 4
  id0 = Get_CAN_Reg(channel, (msg_no) * 16 + 2)               ' identifier registers
  id1 = Get_CAN_Reg(channel, (msg_no) * 16 + 3)
  If (id_length = 4) Then
    id2 = Get_CAN_Reg(channel, (msg_no) * 16 + 4)
    id3 = Get_CAN_Reg(channel, (msg_no) * 16 + 5)
  EndIf
  For counter = 1 To CAN_msg[9]                             ' reading databytes
    CAN_msg[counter] = Get_CAN_Reg(channel, ((msg_no) * 16) + counter + 6)
  Next counter
EndSub


'******************************************************************************
'''Checks, if there is a new frame in the selected
'''+message object. if there is a new frame all databytes are read
'''+and then written to the array "CAN_msg".
'''+The number of dadabytes is written to the element 9 of the array "CAN_msg".
'''+The return value of the function is the identifier of the frame.
'''+If there is no new frame in the message box the return value is -1.
'''channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
'''msg_no: number of the message object
'''****************************************************************************
Function Read_Msg(channel, msg_no, CAN_msg[]) As Long ''<HIDE>
  Dim new As Long                                           ' new message in the message object
  Dim id0, id1, id2, id3 As Long                            ' identifier Byte 0 and 1
  Dim id_length As Long                                     ' buffer to distinguish 11 and 29 bit identifier

  new = Get_CAN_Reg(channel, (msg_no) * 16 + 1) And 3         ' Check, if a new frame in arrived
  If (new = 2) Then                                         ' New frame is arrived
    read_controller_registers(channel, msg_no, id0, id1, id2, id3, id_length, CAN_msg)
    Set_CAN_Reg(channel, (msg_no) * 16, 0FDh)                 ' reset interrupt
    Set_CAN_Reg(channel, (msg_no) * 16 + 1, 85)               ' reset the new data flag
    If (id_length = 0) Then
      Read_Msg = (Shift_Right(id1, 5)) Or (Shift_Left(id0, 3))  ' return value = 11 bit identifier
    Else
      Read_Msg = (Shift_Right(id3, 3)) Or (Shift_Left(id2, 5)) Or (Shift_Left(id1, 13)) Or (Shift_Left(id0, 21))  ' return value = 29 bit identifier
    EndIf
  Else
    Read_Msg = -1                                           ' return value = 0
  EndIf
EndFunction


'******************************************************************************
'''Checks if there is a new frame in the selected
'''+message object. If there is a new frame all databytes are read
'''+and then written to the array "CAN_msg".
'''+The number of databytes is written to the element 9 of the array "CAN_msg".
'''+The return value of the function is the identifier of the frame.
'''+If there is no new frame in the message box the return value is -1.
'''+Checks the consistens of the data and if they ars not consistent
'''+the datas will be reread.
'''channel: number of the CAN interface on the CAN module (also necessary if the module provides only one channel)
'''msg_no: number of the message object
'''*****************************************************************************
Function Read_Msg_Con(channel, msg_no, CAN_msg[]) As Long ''<HIDE>
  Dim new As Long                                           ' new message in the message object
  Dim id_length As Long                                     ' buffer to distinguish 11 and 29 bit identifier
  Dim id0, id1, id2, id3 As Long                            ' identifier Byte 0 and 1

  new = Get_CAN_Reg(channel, (msg_no) * 16 + 1) And 3         ' Check, if a new frame in arrived
  If (new = 2) Then                                         ' New frame is arrived
    Set_CAN_Reg(channel, (msg_no) * 16 + 1, 85)               ' reset the new data flag
    read_controller_registers(channel, msg_no, id0, id1, id2, id3, id_length, CAN_msg)
    new = Get_CAN_Reg(channel, (msg_no) * 16 + 1) And 3       ' Check, if a new frame in arrived
    If (new = 2) Then                                       ' New frame is arrived
      read_controller_registers(channel, msg_no, id0, id1, id2, id3, id_length, CAN_msg)
      Set_CAN_Reg(channel, (msg_no) * 16 + 1, 85)             ' reset the new data flag
    endif
    Set_CAN_Reg(channel, (msg_no) * 16, 0FDh)                 ' reset interrupt
    If (id_length = 0) Then
      Read_Msg_Con = (Shift_Right(id1, 5)) Or (Shift_Left(id0, 3))  ' return value = 11 bit identifier
    Else
      Read_Msg_Con = (Shift_Right(id3, 3)) Or (Shift_Left(id2, 5)) Or (Shift_Left(id1, 13)) Or (Shift_Left(id0, 21))  ' return value = 29 bit identifier
    EndIf
  Else
    Read_Msg_Con = -1                                       ' return value = 0
  EndIf
EndFunction


'******************************************************************************
'''Transmits a frame.
'''channel: number of the CAN interface on the CAN module
'''msg_no: number of the message object
'''+The databytes and the number of databytes have to be written in the
'''+array "CAN_msg" before this Subroutine is activated.
'''+After this Subroutine the frame is transmitted As soon As the
'''+CAN-bus allows it.
'''****************************************************************************
Sub Transmit(channel, msg_no, CAN_msg[]) ''<HIDE>
  Dim buffer As Long
  Dim counter As Long

  For counter = 1 To CAN_msg[9]
    Set_CAN_Reg(channel, ((msg_no) * 10h) + counter + 6, CAN_msg[counter])  'copy datas
  Next counter

  ' Anzahl der Datenbytes bergeben
  buffer = Get_CAN_Reg(channel, ((msg_no) * 10h) + 6)         'read register
  buffer = buffer And 0Fh                                   'change DLC Bits
  buffer = buffer Or Shift_Left(CAN_msg[9], 4)
  Set_CAN_Reg(channel, (msg_no) * 16 + 6, buffer)             'write register
  Set_CAN_Reg(channel, (msg_no) * 16 + 1, 102)                ' Control register (setting bit to transmit data)
EndSub


'******************************************************************************
'''Enables the interrupt of a message object.
'''channel: number of the CAN interface on the CAN module
'''msg_no: number of the message object
'''****************************************************************************
Sub En_CAN_Interrupt(channel, msg_no) ''<HIDE>
  Set_CAN_Reg(channel, (msg_no) * 16, 0EBh)                   'Enable interrupt of the message object.
  Set_CAN_Reg(channel, 0, 02h)                              'Enable global interrupt.
EndSub


'******************************************************************************
'''Sets a register of the CAN-controller.
'''channel: number of the CAN interface on the CAN module
'''regno: register which should be set
'''value: value which should be written to the register.
'''****************************************************************************
Sub Set_CAN_Reg(channel, regno, value) ''<HIDE>
  dim h as long



  SUB_BEGIN_CRITICAL_SECTION
  out(00000410h, value)                                     'write data
 
  nop 
  out(0000040Ah + (channel) * 2, regno)                     'write write adresse adresse

  nops(4)

  do
    nop
    h = IN(00000410h )                                  'wait while busy
  until ((h and 0100h) = 0)
  SUB_END_CRITICAL_SECTION

EndSub


'******************************************************************************
'''Reads a register of the CAN-controller.
'''+return value: value of the register
'''channel: number of the CAN interface on the CAN module
'''+          (also necessary if the module provides only one channel)
'''regno: register to read
'''****************************************************************************
Function Get_CAN_Reg(channel, regno) As Long ''<HIDE>

  SUB_BEGIN_CRITICAL_SECTION
  out(00000402h + (channel) * 2, (regno))                   'write read adress
  nops(4)

  do
    Get_CAN_Reg = IN(00000410h)                               'wait while busy
  until (Get_CAN_Reg and 0100h = 0)
  SUB_END_CRITICAL_SECTION

EndFunction


'******************************************************************************
'''Sets the baudrate of the CAN-Bus.
'''+return value 
'''+                0 = baudrate is set
'''+                1 = the selected baudrate is not set
''' channel: number of the CAN interface on the CAN module
'''+          (also necessary if the module provides only one channel)
'''baud: CAN-Bus baudrate
'''****************************************************************************
Function Set_CAN_Baudrate(channel, baud) As Long ''<HIDE>
  Dim scale As Long
  Dim fbuffer As long
  Dim lbuffer As Long
  Dim back As Long
  Dim tseg1 As Long
  Dim tseg2 As Long
  Dim brp As Long
  Dim btr0 As Long
  Dim btr1 As Long

  dim hscale as long
  dim hbaud as long

  fbuffer = 8000000 / baud

  scale = fbuffer                                           'total scale to achive the baudrate
  hbaud = (fbuffer) * baud

  if (absi(hbaud - 8000000) < 1100) then
    Set_CAN_Baudrate = 0                                    '                                '1 if baudrate not possible
  else
    Set_CAN_Baudrate = 1
  endif


  If (Set_CAN_Baudrate = 0) Then                            'If baudrate possible then find settings

    brp = (scale - 1) / 25                                  'Prescaler

    Do                                                      'find the right brp
      fbuffer = scale / (brp + 1) - 3
      hscale = (fbuffer + 3) * (brp + 1)                    'Inc prescaler Until tseg1 + tseg 2 is an Long
      back = scale - hscale
      Inc(brp)
    Until ((back = 0) Or (fbuffer < 5))
    Dec(brp)
    If (back <> 0) Then Set_CAN_Baudrate = 1

  EndIf

  If (Set_CAN_Baudrate = 0) Then                            'If there is a correct prescaler
    tseg2 = fbuffer * 4 / 10
    tseg1 = fbuffer - tseg2
    If (tseg2 > 7) Then
      Do
        Dec(tseg2)
        Inc(tseg1)
      Until (tseg2 = 7)
    EndIf
    btr0 = brp                                              'Synchronization jump width = 1 (bits = 0)
    btr1 = tseg1 + Shift_Left(tseg2, 4)                     'one sampling each Bit
    Set_CAN_Reg(channel, 0, 65)                             'enable access to btr regisers
    Set_CAN_Reg(channel, 3Fh, btr0)                         'set btr0 regisers
    Set_CAN_Reg(channel, 4Fh, btr1)                         'set btr1 regisers
    Set_CAN_Reg(channel, 0, 0)                              'disable access to btr regisers
  EndIf
EndFunction


#endif

'<ENDREGION>

'<REGION> FIELDBUS

Function Get_IRQ() as long ''<HIDE>
  Get_IRQ = IN(00000080h) and 200h
Endfunction

'---------------------------------------------------------------
' Getting a byte from the DPRAM of a profibus-DP master or slave
' byteno: number of the byte on the DPRAM
'---------------------------------------------------------------
Function Get_Pro_Byte(byteno) As Long ''<HIDE>
  dim in_data as long
  Sub_Begin_Critical_Section
  out(00000082h, (byteno or 08000h))                        'SET ADR
  nop
  out(00000082h, 0000h)                                     'start a read
  nops(6)
  do
    in_data = in(00000080h)
  until ((in_data and 0100h) = 0)                           'wait until, data read
  Sub_END_Critical_Section
  Get_Pro_Byte = (in_data and 0FFH)
EndFunction


'---------------------------------------------------------------
' Setting a byte in the DPRAM of a profibus-DP master or slave
' byteno: number of the byte on the DPRAM
' value:  value for the selected byte
'---------------------------------------------------------------
Sub Set_Pro_Byte(byteno, value) ''<HIDE>
  dim in_data as long
  Sub_Begin_Critical_Section
  out(00000082h, (byteno or 08000h))                        'SET ADR
  nop
  out(00000082h, ((value and 0FFh) or 04000h))              'write write data and start
  nops(6)
  do
    in_data = IN(00000080h)
  until ((in_data and 0100h) = 0)                           'wait until, data written
  Sub_END_Critical_Section
EndSub

'---------------------------------------------------------------
' Hardware reset on the HMS Module
' module:  module address
'---------------------------------------------------------------
Sub ABCC_Reset() ''<HIDE>
  dim abretry as long
  dim state as long
  abretry = 3
  do
    out(00000084h, 1)                                       'reset activ
    sleep(10000)                                            '1  ms
    out(00000084h, 0)                                       'reset inactive
    sleep(15000000)                                         '1.5sec (in 10 nsec)
    state = get_pro_byte(3801h)
    dec abretry
  until ((state = 0) or (abretry = 0))
EndSub

'<ENDREGION>

'<REGION> Media

'*******************************************************************************
'''Writes n x 128  32 bit data words to the media.
'''start_block: 0 to .... return of media_init
'''count_blocks128: number (1.m) of data blocks to be written. A data blocks contains 128 values of 32 bit.
'''source_array[]: array from which data is read.  (long or float)
'''array_start_index: Index (1.n) of the first array element to be transferred.
'''*****************************************************************************
Function Media_Write(start_block, count_blocks128, source_array[], array_start_index) As Long

  dim i as long
  dim s as long
  dim status as long
  
  dim pointer as long 
  
  dim buffer[8] as long at dm_local 

  dim dummy as long 
  dim cmd_resp as long
  dim arg_resp as long
  dim return_val as long
  dim arg as long
  
  Media_Write = 0
    
  out(0464h, count_blocks128)                               ' no of blocks
  out(0466h, start_block)                                   ' adr of 1st block
  sleep(5) 
  
 
  pointer = array_start_index
  return_val = media_response(cmd_resp, arg_resp, 0)        ' cmd25 has R1-response
      
  
  for i = 1 to count_blocks128                              'count_blocks128 *128   
   
    'buffer free?
    'command data_write

    
    do
    until (((in(0460h) and 40000000h) = 0)) ''buffer frei?  
    
    'data_write
    for s = 1 to 16    
      out(046ah, source_array[pointer])
      inc pointer
      out(046ah, source_array[pointer])
      inc pointer
      out(046ah, source_array[pointer])
      inc pointer
      out(046ah, source_array[pointer])
      inc pointer
      out(046ah, source_array[pointer])
      inc pointer
      out(046ah, source_array[pointer])
      inc pointer
      out(046ah, source_array[pointer])
      inc pointer
      out(046ah, source_array[pointer])
      inc pointer
    next
    nop                                                     'sync buffer
    nop
  next
 
      
  do
  until ((in(0460h) and 20000000h) = 20000000h)
       
  status = in(46ch)                                         ' read error register clear by read 
  media_write = media_write or status
ENDFunction


'*******************************************************************************
'''Reads n x 128 (32 bit data words) from the media.
'''+return value 0 = OK   <>0 Error
'''start_block: Index (1.m) of the first data block on the memory card which is to be read
'''count_blocks128: Number (1.m) of data blocks to be read. A data blocks contains 128 values of 32 bit
'''destination_array[]:   Array where data is written to.Both data types Long or Float are allowed.
'''array_start_index:
'''******************************************************************************
Function Media_Read(start_block, count_blocks128, destination_array[], array_start_index) As Long
  'return 0 =0K

  dim i as long
  dim cnt as long
  dim s as long
  dim status as long
  dim pointer as long 
  dim cmd_resp as long
  dim arg_resp as long
  dim return_val as long
  dim busy as long
 
  dim t2, t1 as long
  
  
  pointer = array_start_index
  Media_Read = 0 
    
  out(464h, count_blocks128)                                ' no of blocks  
  out(468h, start_block)                                    'startblock +cmd rd
  sleep(5)                                                  ' sleep mandatory
  
  return_val = media_response(cmd_resp, arg_resp, 1)
  if (return_val <> 0) then media_read = media_read or 400000H
  if (cmd_resp <> 18) then media_read = media_read or 200000H
  if (arg_resp <> 900H) then media_read = media_read or 100000H
  
  
  for i = 1 to count_blocks128                              'count_blocks128 *128
    
    'command data_read
      
    t1 = read_timer()
    
       
    do 
      t2 = read_timer() - t1
      status = in(0460h) and 80000000h
      if ((status <> 0) AND (t2 > 1000000000)) then
        status = 1
        media_read = media_read or 800000H
      endif 
    until (status <> 0)
    ' 
    
    'data_read
    for s = 1 to 16
      destination_array[pointer] = in(480h)
      inc pointer
      destination_array[pointer] = in(480h)
      inc pointer
      destination_array[pointer] = in(480h)
      inc pointer
      destination_array[pointer] = in(480h) 
      inc pointer
      destination_array[pointer] = in(480h) 
      inc pointer
      destination_array[pointer] = in(480h)
      inc pointer
      destination_array[pointer] = in(480h)
      inc pointer
      destination_array[pointer] = in(480h)      
      inc pointer
   
      
    next 
  next
      
  t1 = read_timer()
  
  
  do
    t2 = read_timer() - t1
    status = in(0460h) and 20000000h
    if ((status <> 20000000h) AND (t2 > 1000000000)) then
      status = 1
      media_read = media_read or 800000H
    endif 
  until (status <> 0)
  
  status = in(46ch)                                         ' read error register clear by read 
  Media_Read = media_read or status
  
ENDFunction



function media_response(cmd_resp, arg_resp, busycheck) as long  '<HIDE>
 
  '' 1(00)h: timeout
  '' 2(00)h: response received
  '' 3(00)h: crc-error
  '     busycheck 1= true 
  '                0= false
  dim resp1, resp4, resp5, transmission, busy as long
  dim t1, t2 as long
  
  t1 = read_timeR()
  
  do 
    t2 = read_timer() - t1
    resp1 = in(460h)
    ' resp4=peek(0c000466h)
    'resp5=peek(0c000468h)
    ' transmission=shift_right((resp1 and 300h), 8)
    transmission = shift_right((resp1 and 00c00000h), 22)
    
    if (t2 > 2000000000) then                               'timeout 6.6 sec
      if (transmission = 0) then transmission = 1
    endif 
  
  until (transmission <> 0) 
   
  cmd_resp = shift_right(resp1, 16) and 03fh                ' Response: Kommando-wort (=command index)
  arg_resp = resp1 and 1fffh                                ' Response: Bits 12..0 of 32-Bit-Status-Wort
    
    
  ' 1(00)h: timeout
  ' 2(00)h: response received
  ' 3(00)h: crc-error
     
  if (transmission = 2) then 
    
    '  if (busycheck=1) then
    '   do  
    '    busy=peek(0c000478h)
    '   nop
    '   nop
    ' until (busy=1)   
    'endif
      
      
    media_response = 0
  else
    media_response = transmission
  endif
  
endfunction

'<ENDREGION>















